#include "motif.macros"


MakePanel(schedulerTBL,schedulerTBLTBL, Scheduler)
schedulerTBL.wcAfterManageChildren:  XetAction(buildSchedulerList)

*schedulerTBLTBL.wcCreate:	      XmpTable
UnifiedTableLayout(*schedulerTBLTBL)
*schedulerTBLTBL.wcChildren:	      schedulerListTBL, movieBuilderTBL
   
*schedulerTBLTBL.Layout:	      schedulerListTBL     0 0 WH; \
				      movieBuilderTBL      0 1 WH

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
*schedulerListTBL.wcCreate:	      XmpTable
*schedulerListTBL.wcChildren:	      schedListTitle,  \
				      schedListTitle1, \
				      schedListTBL,    \
				      schedulerButtonTBL
    
*schedulerListTBL.layout:	      schedListTitle        0 0 WH; \
				      schedListTitle1       0 1   ; \
				      schedListTBL          0 2 WH; \
				      schedulerButtonTBL    0 3 

UnifiedBorderWidth(*schedulerListTBL)
UnifiedTitle(schedListTitle, <<<<< List of Animation Objects >>>>>)


*schedListTitle1.wcCreate:            XmLabel
*schedListTitle1.labelString: Slot  \     Name   \     Type  \   <Interval(msec), No. of clips, Status>
*schedListTitle1.alignment:   ALIGNMENT_BEGINNING

*schedListTBL.wcCreate:		      XmScrolledWindow
*schedListTBL.wcChildren:	      schedList
*schedListTBL.layout:		      schedList 0 0 
*schedListTBL.width:		      620

MakeListWidget(*schedList,6)

*schedList.wcPopups:                  schedPopupMenu
*schedList.translations:   #override \n <Btn3Down>: XmpPopup( this*schedPopupMenu)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

*schedulerButtonTBL.wcCreate:         XmpTable
*schedulerButtonTBL.wcChildren:       \
                                      schedulerDeleteAll,   \
				      schedulerFreezeAll,   \
				      schedulerUnfreezeAll, \
                                      schedulerCancel,      \
				      schedulerResetAll,    \
				      schedulerReverseClipAll,    \
                                      schedulerToRootWinAll, \
                                      schedulerToDAALL,      \
				      schedulerReverseAll 

*schedulerButtonTBL.layout:           \
				      schedulerDeleteAll       0 0; \
				      schedulerFreezeAll       1 0; \
				      schedulerUnfreezeAll     1 1; \
				      schedulerResetAll        0 1; \
				      schedulerReverseAll      2 0; \
				      schedulerReverseClipAll  2 1; \
                                      schedulerCancel          4 0; \
                                      schedulerToRootWinAll    3 0; \
                                      schedulerToDAALL         3 1; \


globalButtonSpacing(schedulerButtonTBL)

MakePushButton(schedulerRename, Rename, WcSetInsensitive(this)  XetAction(schedulerRename))
MakePushButton(schedulerToRootWinAll,Set Output to Root Window, XetAction(schedulerToRootWinAll))
MakePushButton(schedulerToDAALL,Set Output to Drawing Area,XetAction(schedulerToDAALL))

MakePushButton(schedulerFreezeAll, Freeze, XetAction(freezeMotion))
MakePushButton(schedulerUnfreezeAll, Unfreeze, XetAction(unfreezeMotion))
MakePushButton(schedulerFreeze, Freeze,   XetAction(schedulerFreeze))
MakePushButton(schedulerUnfreeze, Unfreeze,   XetAction(schedulerUnfreeze))
MakePushButton(schedulerMoveToMovie,  Copy To Movie Builder, XetAction(schedulerMoveToMovie))
MakePushButton(schedulerDelete,  Delete, XetAction(schedulerDelete))
MakePushButton(schedulerDeleteAll,  Delete, XetAction(schedulerDeleteAll))
MakePushButton(schedulerEdit,       Edit, XetAction(schedulerEdit))
MakePushButton(schedulerReverse,  Reverse Course, XetAction(schedulerReverse))
MakePushButton(schedulerReverseClip, Reverse Clip,XetAction(schedulerReverseClip))
MakePushButton(schedulerReverseAll,Reverse  Course,XetAction(schedulerReverseAll))
MakePushButton(schedulerReverseClipAll,Reverse Clip,XetAction(schedulerReverseClipAll))
MakePushButton(schedulerReset,       Reset, XetAction(schedulerReset))
MakePushButton(schedulerResetAll,     Reset, XetAction(schedulerResetAll))
MakePushButton(schedulerDuplicate,  Duplicate, XetAction(schedulerDuplicate))
MakePushButton(schedulerWrite,  Write , WcSetInsensitive(this) XetAction(preschedulerWrite))
MakePushButton(schedulerCancel,       Cancel,XetAction(schedulerCancel) WcDestroy(schedulerTBL*schedPopupMenu) WcDestroy(schedulerTBL*moviePopupMenu) WcDestroy(schedulerTBL))
 

*schedPopupMenu.wcConstructor:	   XmCreatePopupMenu
*schedPopupMenu.wcChildren:	   schedulerFreeze,schedulerUnfreeze,\
				   schedulerMoveToMovie,schedulerEdit,\
				   schedulerReverseClip,schedulerReverse, \
				   schedulerDestination,schedulerReset,\
				   schedulerDuplicate,schedulerRename, \
				   schedulerWrite,schedulerDelete

*schedPopupMenu.wcPopups:          schedOutputMenu

*schedulerDestination.wcCreate:           XmCascadeButton
*schedulerDestination.labelString:        Set Output Destination
*schedulerDestination.borderWidth:        2 
*schedulerDestination.marginWidth:        2 
*schedulerDestination.traversalOn:        False
*schedulerDestination.highlightOnEnter:   True
*schedulerDestination.highlightThickness: 2 
*schedulerDestination.bottomShadowColor:  XET_BLACK
*schedulerDestination.topShadowColor:     XET_WHITE
*schedulerDestination.shadowThickness:    4 
*schedulerDestination.fontList: -*-new century schoolbook-bold-r-*-*-20-140-*
*schedulerDestination.borderColor:        XET_BLACK
*schedulerDestination.subMenuId:         *schedOutputMenu

*schedOutputMenu.wcConstructor:	   XmCreatePulldownMenu
*schedOutputMenu.wcChildren:       schedOutputDrawingArea, schedOutputRoot
MakeStatusButton(schedOutputMenu,schedOutputDrawingArea, Drawing Area, XetAction(schedOutputDrawingArea))
MakeStatusButton(schedOutputMenu,schedOutputRoot, Root Window, XetAction(schedOutputRoot))

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
*movieBuilderTBL.wcCreate:	   XmpTable
*movieBuilderTBL.wcChildren:	   movieListTitle,  \
				   movieListTitle1,  \
				   movieListFieldsTBL, \
				   movieListTBL,    \
				   movieButtonTBL
 
*movieBuilderTBL.layout:	   movieListTitle     0 0 WH; \
				   movieListFieldsTBL 0 1 WH; \
				   movieListTitle1    0 2   ; \
				   movieListTBL       0 3 WH; \
				   movieButtonTBL     0 4

UnifiedBorderWidth(*movieBuilderTBL)

UnifiedTitle(movieListTitle, <<<<<  Movie Object Builder >>>>>)

*movieListTitle1.wcCreate:         XmLabel
*movieListTitle1.labelString: Slot    \   Name    \    Type \    Interval(msc) \  <Termination criterion>
*movieListTitle1.alignment:        ALIGNMENT_BEGINNING

*movieListFieldsTBL.wcCreate:      XmpTable
*movieListFieldsTBL.wcChildren:    movieNameLB,movieNameTF
*movieListFieldsTBL.layout:        movieNameLB 0 0; movieNameTF 1 0

MakeLBandTF(*movieNameLB,*movieNameTF, Movie Name: )

*movieListTBL.wcCreate:		   XmScrolledWindow
*movieListTBL.wcChildren:	   movieList
*movieListTBL.layout:		   movieList 0 0 
*movieListTBL.width:		   620

MakeListWidget(*movieList,6)

*movieList.wcPopups:               moviePopupMenu
*movieList.translations:   #override \n <Btn3Down>: XmpPopup( this*moviePopupMenu)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

*movieButtonTBL.wcCreate:          XmpTable
*movieButtonTBL.wcChildren:        \
                                   movieDeleteAll,   \
				   movieCommit

*movieButtonTBL.layout:            \
				   movieDeleteAll  0 0; \
				   movieCommit     1 0

globalButtonSpacing(movieButtonTBL)

MakePushButton(movieRehearse,   Rehearse,  WcSetInsensitive(this)  XetAction(movieRehearse))
MakePushButton(movieMoveUp, Move Up,   XetAction(movieMoveUp))
MakePushButton(movieMoveDown, Move Down,   XetAction(movieMoveDown))
MakePushButton(movieMoveToFirst,  Move to First, XetAction(movieMoveToFirst))
MakePushButton(movieDelete,       Delete, XetAction(movieDelete))
MakePushButton(movieExtract, Extract, XetAction(movieExtract))
MakePushButton(movieDeleteAll,  Delete  All, XetAction(movieDeleteAll))
MakePushButton(movieMoveToLast,       Move to Last, XetAction(movieMoveToLast))
MakePushButton(movieSetTermCond,   Set Termination criterion, XetAction(movieSetTermCond))
MakePushButton(movieCommit,       Commit, XetAction(movieCommit))

*moviePopupMenu.wcConstructor:	   XmCreatePopupMenu
*moviePopupMenu.wcChildren:	   movieMoveUp,movieMoveDown,\
				   movieMoveToFirst,movieMoveToLast,\
				   movieSetTermCond, movieExtract, \
				   movieDelete
