//
//  Xet - X Entertainment (a tool to create animated images)
//
//
//  Author:   Ko-Haw Nieh & Coalition Software, (nieh@netcom.com)
//
//
//  Copyright 1992, 1993 by Ko-Haw Nieh & Coalition Software
//
// Permission to use, copy, and distribute for non-commercial purposes,
// is hereby granted without fee, providing that the above copyright
// notice appear in all copies and that both the copyright notice and this
// permission notice appear in supporting documentation. 
//
// This software is provided as-is and without any warranty of any kind.

#ifndef WCL_INTERPRETER_H
#define WCL_INTERPRETER_H

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xm/Xm.h>		// Motif and Xt Intrinsics	
extern "C" {
#include <X11/Wc/WcCreate.h>	// Widget Creation Library	
#include <X11/Xmp/Xmp.h>	// Motif Public widgets etc.	
}

class WCLInterpreter {
protected:
  XtAppContext    app;
  Widget          appShell;
public:
  WCLInterpreter(char *resName,int argc, char* argv[]);
  ~WCLInterpreter(){}
  void		  RegisterActions();
  void		  RegisterCallbacks();
  void		  RegisterExternalWidgets ();
  void		  Realize();
  void		  CreateAll();
  void            removeXtAddInput(XtInputId id);
  void            flush();
  void            run();
  XtIntervalId    registerXtAddTimeOut(unsigned long interval,
				     XtTimerCallbackProc proc,
				     XtPointer ptr);
  XtInputId       registerXtAddInput(int fp, 
				     XtInputCallbackProc readMakeResult, 
				     XtPointer);
  // convenience functions
  Widget  	nameToWidget(char *s);
  Widget    	rAppShell()            {return appShell;};

};

#endif


