//
//  Xet - X Entertainment (a tool to create animated images)
//
//
//  Author:   Ko-Haw Nieh & Coalition Software, (nieh@netcom.com)
//
//
//  Copyright 1992, 1993 by Ko-Haw Nieh & Coalition Software
//
// Permission to use, copy, and distribute for non-commercial purposes,
// is hereby granted without fee, providing that the above copyright
// notice appear in all copies and that both the copyright notice and this
// permission notice appear in supporting documentation. 
//
// This software is provided as-is and without any warranty of any kind.

#include <math.h>
#include <string.h>

// this kind of functions takes one argument
struct builtInMathFunc1 {
  char   *name;
  double (*FuncD)(double);
};

// this kind of functions takes two arguments
struct builtInMathFunc2 {
  char   *name;
  double (*FuncD)(double,double);
};

struct builtInMathFunc1 builtIn1[] =  {
  {"abs",   fabs},
  {"sin",   sin},
  {"cos",   cos},
  {"tan",   tan},
  {"asin",  asin},
  {"acos",  acos},
  {"atan",  atan},
  {"exp",   exp},
  {"expm1", expm1},
  {"exp2",  exp2},
  {"exp10", exp10},
  {"log",   log},
  {"log1p", log1p},
  {"log2",  log2},
  {"log10", log10},
  {"",      NULL},
};

struct builtInMathFunc2 builtIn2[] = {
  {"atan2",    atan2},
  {"pow",      pow},
  {"",         NULL},
};

double evalBuildInFuncD1(char *s,double v1){
  int i;
  for(i=0;;i++){
    if(strcmp(s,builtIn1[i].name) == 0){
      return builtIn1[i].FuncD(v1);
    }
    if(strcmp("",builtIn1[i].name)==0)
      break;
  }
  return 0;
}

int evalBuildInFuncD(char *s,double *rtn,double v1,double v2){
  int i;
  for(i=0;;i++){
    if(strcmp(s,builtIn1[i].name) == 0){
      *rtn = builtIn1[i].FuncD(v1);
      return 1;
    }
    if(strcmp("",builtIn1[i].name)==0)
      break;
  }
  for(i=0;;i++){
    if(strcmp(s,builtIn2[i].name) == 0){
      *rtn = builtIn2[i].FuncD(v1,v2);
    }
    if(strcmp("",builtIn1[i].name)==0)
      break;
  }
  return 0;
}
