//
//  Xet - X Entertainment (a tool to create animated images)
//
//
//  Author:   Ko-Haw Nieh & Coalition Software, (nieh@netcom.com)
//
//
//  Copyright 1992, 1993 by Ko-Haw Nieh & Coalition Software
//
// Permission to use, copy, and distribute for non-commercial purposes,
// is hereby granted without fee, providing that the above copyright
// notice appear in all copies and that both the copyright notice and this
// permission notice appear in supporting documentation. 
//
// This software is provided as-is and without any warranty of any kind.

#ifndef CLIPLIST_H
#define CLIPLIST_H

#include <X11/Intrinsic.h>
#include "clip.h"
#include "config.h"
#include "clipsTable.h"
#include <stdio.h>

class ClipListEntry {
public:
  Clip             *clip;
  ClipListEntry    *next;
  ClipListEntry    *prev;
  ClipListEntry():clip(NULL),next(NULL),prev(NULL) {}
};


class ClipList {
protected:
  Dir              dir;
  int              size;
  ClipsTable      *clipsPool;
  ClipListEntry   *current;
  ClipListEntry   *head;
public:
  ClipList(char *s, ClipsTable *);
  ClipList(const ClipList &cl);
  ~ClipList();
  Clip		  *nextClip();
  char		  *getListofNames();
  int		   Size();
  void		   reset();
  void		   reverse();
  void		   incrRefCounter();
  void		   decrRefCounter();
  void		   writeOut(FILE *fp);

};

#endif
