//
//  Xet - X Entertainment (a tool to create animated images)
//
//
//  Author:   Ko-Haw Nieh & Coalition Software, (nieh@netcom.com)
//
//
//  Copyright 1992, 1993 by Ko-Haw Nieh & Coalition Software
//
// Permission to use, copy, and distribute for non-commercial purposes,
// is hereby granted without fee, providing that the above copyright
// notice appear in all copies and that both the copyright notice and this
// permission notice appear in supporting documentation. 
//
// This software is provided as-is and without any warranty of any kind.

#include "cloneImage.h"
#include "util.h"
#include "config.h"

CloneImage::CloneImage(Clip *c)
     : Clip()
{
  original_clip = c;
  c->incrRefCounter();
  RefCounter  = 0;
  Dpy         = c->getDisplay();
  drawingArea = c->getDrawingArea();
  width       = c->Width();
  height      = c->Height();
  clipStatus  = c->getClipStatus();
  gc          = c->GetGC();
  image       = c->GetImage();
  shapeMask   = c->copyMask();
  ALLOC_STRCPY(shapeFileName,c->getShapeFileName());
  ALLOC_STRCPY(diskFileName,c->getDiskFileName());
  ALLOC_STRCPY(clipName,c->getClipName());
  IsClone = 1;
}

CloneImage::~CloneImage() {
  original_clip->decrRefCounter();
  deallocateString();
}

Clip *CloneImage::dup(){
  CloneImage *rtn = new CloneImage(original_clip); 
  return rtn;
}
