//
//  Xet - X Entertainment (a tool to create animated images)
//
//
//  Author:   Ko-Haw Nieh & Coalition Software, (nieh@netcom.com)
//
//
//  Copyright 1992, 1993 by Ko-Haw Nieh & Coalition Software
//
// Permission to use, copy, and distribute for non-commercial purposes,
// is hereby granted without fee, providing that the above copyright
// notice appear in all copies and that both the copyright notice and this
// permission notice appear in supporting documentation. 
//
// This software is provided as-is and without any warranty of any kind.

#ifndef COLORHIST_H
#define COLORHIST_H
#include <libc.h>
#include "hash.h"

class ColorEntry {
public:
  unsigned long pixval;
  unsigned long occurrence;
  unsigned char red;
  unsigned char green;
  unsigned char blue;
};

class ColorHist : public Hash {
protected:
  int      size;
  int      current;     
  char     key[4];
  int      loopIdx;
public:
  ColorHist(int size);
  ~ColorHist();
  int         howMany();
  void        makeKey(unsigned char r,unsigned char g, unsigned char b);
  int         Hinsert(unsigned char r,unsigned char g, unsigned char b);
  ColorEntry *Hfind(unsigned char r,unsigned char g, unsigned char b);
  void        startLooping();
  ColorEntry *nextEntry();
  void        clearEverything();
};

#endif

