//
//  Xet - X Entertainment (a tool to create animated images)
//
//
//  Author:   Ko-Haw Nieh & Coalition Software, (nieh@netcom.com)
//
//
//  Copyright 1992, 1993 by Ko-Haw Nieh & Coalition Software
//
// Permission to use, copy, and distribute for non-commercial purposes,
// is hereby granted without fee, providing that the above copyright
// notice appear in all copies and that both the copyright notice and this
// permission notice appear in supporting documentation. 
//
// This software is provided as-is and without any warranty of any kind.

#ifndef MATH_EXPR_H
#define MATH_EXPR_H

#include "expr_yacc.h"
#include <stdio.h>

typedef union  {
         char     strval[30];
         double   dval;
         int      ival;
} YYSTYPE;

typedef struct {
            char    name[20];
            double  value;
} ValuedSymbol;

enum ParsingStatus {successful_E, failed_E,};

class Math_Expr {
private:
  FILE          *yeyin;
  int            lineno;
  char          *Hstring_to_evaluate;
  ValuedSymbol   valuedSymbol[10];
  int            ival;
  double         val;
  YYSTYPE        yeylval, yeyval;
  int            getc_index;
  double         result;
  ParsingStatus  parsingStatus;
  double         currentValue;
public:
  Math_Expr();
  Math_Expr(char *Hstring_to_evaluate);
  ~Math_Expr();
  void		 SetInputHstring(char *s);
  char		*getExprInString();
  int		 Getc();
  int		 yeylook();
  int		 yeyinput();
  int		 yeyparse();
  int		 yeywrap();
  void		 yeyoutput(int c);
  void		 yeyunput(int c);
  void		 yeyerror(char *);
  int		 yeylex();
  double	 GetResult();
  double	 evalFunc(char *);
  double	 evalFunc(char *,double);
  double	 evalFunc(char *,double, double);
  void		 setCurrentValue(char *n, double);
  double	 getCurrentValue(char *);
  ParsingStatus  evaluate();
};

#endif


