%e  5000
%o  10000
%k  2000
%p  7500
%n  1000
%a  10000
%{
/*
  Xet - X Entertainment (a tool to create animated images)


  Author:   Ko-Haw Nieh & Coalition Software, (nieh@netcom.com)


  Copyright 1992, 1993 by Ko-Haw Nieh & Coalition Software

 Permission to use, copy, and distribute for non-commercial purposes,
 is hereby granted without fee, providing that the above copyright
 notice appear in all copies and that both the copyright notice and this
 permission notice appear in supporting documentation. 

 This software is provided as-is and without any warranty of any kind.
*/

#include "expr.h"
#include <string.h>
int ival;
double val;
extern YYSTYPE yylval, yyval;

%}

a	[aA]
b	[bB]
c	[cC]
d	[dD]
e	[eE]
f	[fF]
g	[gG]
h	[hH]
i	[iI]
j	[jJ]
k	[kK]
l	[lL]
m	[mM]
n	[nN]
o	[oO]
p	[pP]
q	[qQ]
r	[rR]
s	[sS]
t	[tT]
u	[uU]
v	[vV]
w	[wW]
x	[xX]
y	[yY]
z	[zZ]

%%
[ \t]             { ; }   /* skip blanks and tabs */
\n                { lineno++;}
[-]?[0-9][0-9]* { sscanf(yytext,"%d",&ival); yylval.ival = ival;
                      /* printf("an integer number = %d\n",ival); */
                      return(INTEGER_VAL);
                  }
[-]?[0-9]+\.?|[-]?[0-9]*\.[0-9]+  {
                      sscanf(yytext,"%lf",&val); yylval.dval = val;
                      /* printf("a floating number = %f\n",val); */
                      return(FLOAT_VAL);
                  }
\"[^"]*           { if (yytext[yyleng-1] == '\\')
                        yymore();
                    else{
                      if(lex_input() == '"'){
                          yytext[yyleng] = '"';
                          yytext[yyleng+1] = '\0';
                       }}
                    /* yylval.strval = new char[strlen(yytext)+1]; */
                    strcpy(yylval.strval,yytext); 
                    return(HSTRING_VAL);}
\'..*\'           {printf("text Hstring = %s\n",yytext);
                    /* yylval.strval = new char[strlen(yytext)+1]; */
                    strcpy(yylval.strval,yytext);
                    return(HSTRING_VAL);}
"="               {return(EQUAL_SIGN);}

"=="              {return(EQ);}
"<"               {return(LESS);}
">"               {return(GREATER);}
"!="              {return(NOTEQ);}
">="              {return(GREATEREQ);}
"<="              {return(LESSEQ);}

","               {return(COMMA);}
"@"               {return(ATSIGN);}
";"               {return(SEMICOLON);}
":"               {return(COLON);}
"?"               {return(QMARK);}
"("               {return(LPAREN);}
")"               {return(RPAREN);}
"["               {return(LRECT);}
"]"               {return(RRECT);}
"+"               {return(PLUS);}
"-"               {return(MINUS);}
"*"               {return(MULTIPLY);}
"/"               {return(DIVIDE);}

#.*\n             { ; }  /* skip comments
[a-zA-Z_][a-zA-Z0-9_]*   {
                           /* yylval.strval = new char[strlen(yytext)+1]; */
                           strcpy(yylval.strval,yytext); 
                       /* printf("an identifier = %s\n",yytext); */
                       return(IDENTIFIER);
                  }

.                 { /* printf("everything else = %s\n",yytext); */
                     return(UNKNOWN);}

%%

