/*
  Xet - X Entertainment (a tool to create animated images)


  Author:   Ko-Haw Nieh & Coalition Software, (nieh@netcom.com)


  Copyright 1992, 1993 by Ko-Haw Nieh & Coalition Software

 Permission to use, copy, and distribute for non-commercial purposes,
 is hereby granted without fee, providing that the above copyright
 notice appear in all copies and that both the copyright notice and this
 permission notice appear in supporting documentation. 

 This software is provided as-is and without any warranty of any kind.

*/


%{
#include "expr.h"
%}
%type <dval> fexpr specification identifier 

%token IDENTIFIER  IDENTIFIER
%token HSTRING_VAL FLOAT_VAL INTEGER_VAL 
%token EQUAL EQUAL_SIGN UNKNOWN  PLUS MINUS DIVIDE MULTIPLY 
%token EQ LESS GREATER NOTEQ GREATEREQ LESSEQ QMARK
%token COMMA LESSTHAN
%token ATSIGN
%token SEMICOLON
%token COLON
%token LPAREN
%token RPAREN
%token LRECT
%token RRECT

%left   PLUS MINUS
%left   DIVIDE MULTIPLY 
%left   UMINUS QMARK  COLON

%right  EQ LESS GREATER NOTEQ GREATEREQ LESSEQ

%start  specification
%%
specification :  fexpr {result = $1;}
              ;

fexpr   : fexpr   PLUS      fexpr	      {$$ = $1 + $3;}
        | fexpr   MINUS     fexpr	      {$$ = $1 - $3;}
        | fexpr   MULTIPLY  fexpr	      {$$ = $1 * $3;}
        | fexpr   DIVIDE    fexpr	      {$$ = $1 / $3;}
        | fexpr   EQ        fexpr	      {$$ = $1 == $3;}
        | fexpr   NOTEQ     fexpr	      {$$ = $1 != $3;}
        | fexpr   LESS      fexpr	      {$$ = $1 < $3;}
        | fexpr   GREATER   fexpr	      {$$ = $1 > $3;}
        | fexpr   GREATEREQ fexpr	      {$$ = $1 >= $3;}
        | fexpr   LESSEQ    fexpr	      {$$ = $1 <= $3;}
	| fexpr   QMARK     fexpr COLON fexpr {$$ = $1 ? $3 : $5;}
        | LPAREN  fexpr     RPAREN            {$$ = $2;}
        | MINUS   fexpr     %prec UMINUS      {$$ = - $2;}
        | identifier                          {$$ = $1;}
        | FLOAT_VAL                           {$$ = $<dval>1;}
        | INTEGER_VAL                         {$$ = $<ival>1;}
        ;

identifier   : IDENTIFIER { $$ = getCurrentValue($<strval>1);}
             | IDENTIFIER LPAREN RPAREN  {$$ = evalFunc($<strval>1);}
             | IDENTIFIER LPAREN fexpr  RPAREN
	               {$$ = evalFunc($<strval>1,$3);}
             | IDENTIFIER LPAREN fexpr COMMA fexpr RPAREN
	               {$$ = evalFunc($<strval>1,$3,$5);}
             ;

%%

