//
//  Xet - X Entertainment (a tool to create animated images)
//
//
//  Author:   Ko-Haw Nieh & Coalition Software, (nieh@netcom.com)
//
//
//  Copyright 1992, 1993 by Ko-Haw Nieh & Coalition Software
//
// Permission to use, copy, and distribute for non-commercial purposes,
// is hereby granted without fee, providing that the above copyright
// notice appear in all copies and that both the copyright notice and this
// permission notice appear in supporting documentation. 
//
// This software is provided as-is and without any warranty of any kind.

#ifndef LOCUSTABLE_H
#define LOCUSTABLE_H

#include <X11/Intrinsic.h>
#include "locus.h"
#include "hash.h"

class LocusTable : public Hash {
protected:
  int     size;
  int     current;
  int     dup_index;
public:
  LocusTable(int size = 10);
  ~LocusTable();
  Locus  *dup(char *name);
  Locus  *findLocus(char *name);
  int     Size();
  int     addLocus(char *name,Locus *c);
  void    buildLocusXmList(Widget w);
  void    clearEverything();
  void    deleteLocus();
  void    deleteLocus(char *name);
  void    renameKey(char *Old, char *New);
  void    writeOut(FILE *fp);
};

#endif
