//
//  Xet - X Entertainment (a tool to create animated images)
//
//
//  Author:   Ko-Haw Nieh & Coalition Software, (nieh@netcom.com)
//
//
//  Copyright 1992, 1993 by Ko-Haw Nieh & Coalition Software
//
// Permission to use, copy, and distribute for non-commercial purposes,
// is hereby granted without fee, providing that the above copyright
// notice appear in all copies and that both the copyright notice and this
// permission notice appear in supporting documentation. 
//
// This software is provided as-is and without any warranty of any kind.

#include "WCLiptr.h"
#include  <osfcn.h>
#include <libc.h>
#include "xet.h"
#include "wrapper.h"

XtActionsRec  ActionPool[] = {
      "FSBCancel",                    (XtActionProc) FSBCancel,
      "FSBUpdateImportFilename",      (XtActionProc) FSBUpdateImportFilename,
      "ReInitialize",                 (XtActionProc) ReInitialize,
      "bgroundCancel",                (XtActionProc) bgroundCancel,
      "bgroundDoit",                  (XtActionProc) bgroundDoit,
      "buildClipList",                (XtActionProc) buildClipList,
      "buildSchedulerList",           (XtActionProc) buildSchedulerList,
      "buildSpoolList",               (XtActionProc) buildSpoolList,
      "cleaninfotxt",                 (XtActionProc) cleaninfotxt,
      "clearDrawingArea",             (XtActionProc) clearDrawingArea,
      "clipAttribApply",              (XtActionProc) clipAttribApply,
      "clipAttribCancel",             (XtActionProc) clipAttribCancel,
      "clipCancel",                   (XtActionProc) clipCancel,
      "clipSave",                     (XtActionProc) clipSave,
      "cliprehearse",                 (XtActionProc) cliprehearse,
      "clipstoprehearse",             (XtActionProc) clipstoprehearse,
      "cmapfilenameCancel",           (XtActionProc) cmapfilenameCancel,
      "cmapfilenameTBL",              (XtActionProc) cmapfilenameTBL,
      "colorFreeCells",               (XtActionProc) colorFreeCells,
      "colorSelCancel",               (XtActionProc) colorSelCancel,
      "colorSelPastebg",              (XtActionProc) colorSelPastebg,
      "colorSelPastefg",              (XtActionProc) colorSelPastefg,
      "colorSelectPanel",             (XtActionProc) colorSelectPanel,
      "configClipsCancel",            (XtActionProc) configClipsCancel,
      "configClipsClone",             (XtActionProc) configClipsClone,
      "configClipsDelete",            (XtActionProc) configClipsDelete,
      "configClipsDeleteAll",         (XtActionProc) configClipsDeleteAll,
      "configClipsDeleteMask",        (XtActionProc) configClipsDeleteMask,
      "configClipsDup",               (XtActionProc) configClipsDup,
      "configClipsInfo",              (XtActionProc) configClipsInfo,
      "configClipsQuantize",          (XtActionProc) configClipsQuantize,
      "configClipsRename",            (XtActionProc) configClipsRename,
      "configClipsSetStatus",         (XtActionProc) configClipsSetStatus,
      "configClipsShow",              (XtActionProc) configClipsShow,
      "configClipsShowAll",           (XtActionProc) configClipsShowAll,
      "configENV",                    (XtActionProc) configENV,
      "configENVApply",               (XtActionProc) configENVApply,
      "configENVCancel",              (XtActionProc) configENVCancel,
      "corpCancel",                   (XtActionProc) corpCancel,
      "corpbgArea",                   (XtActionProc) corpbgArea, 
      "cropArea",                     (XtActionProc) cropArea,
      "destroyBackground",            (XtActionProc) destroyBackground,
      "drawGrid10",                   (XtActionProc) drawGrid10,
      "drawGrid100",                  (XtActionProc) drawGrid100,
      "drawGrid20",                   (XtActionProc) drawGrid20,
      "drawGrid200",                  (XtActionProc) drawGrid200,
      "drawGrid5",                    (XtActionProc) drawGrid5,
      "drawGrid50",                   (XtActionProc) drawGrid50,
      "dumpinfotxt",                  (XtActionProc) dumpinfotxt,
      "editLocusAccept",              (XtActionProc) editLocusAccept,
      "editLocusPoints",              (XtActionProc) editLocusPoints,
      "editLocusUnique",              (XtActionProc) editLocusUnique,
      "fileNameCancel",               (XtActionProc) fileNameCancel,
      "forgeApply",                   (XtActionProc) forgeApply,
      "forgeCancel",                  (XtActionProc) forgeCancel,
      "freezeLogo",                   (XtActionProc) freezeLogo,
      "freezeMotion",                 (XtActionProc) freezeMotion,
      "imporFlip_trotate270",         (XtActionProc) imporFlip_trotate270,
      "importCancel",                 (XtActionProc) importCancel,
      "importDoit",                   (XtActionProc) importDoit,
      "importFlip_leftright",         (XtActionProc) importFlip_leftright,
      "importFlip_rotate180",         (XtActionProc) importFlip_rotate180,
      "importFlip_rotate90",          (XtActionProc) importFlip_rotate90,
      "importFlip_topbottom",         (XtActionProc) importFlip_topbottom,
      "importFlip_transpose",         (XtActionProc) importFlip_transpose,
      "importfetchinfo",              (XtActionProc) importfetchinfo,
      "loadcmap",                     (XtActionProc) loadcmap,
      "loadcmapCancel",               (XtActionProc) loadcmapCancel,
      "loadlocus",                    (XtActionProc) loadlocus,
      "loadlocusCancel",              (XtActionProc) loadlocusCancel,
      "loadxetfile",                  (XtActionProc) loadxetfile,
      "loadxetfilecancel",            (XtActionProc) loadxetfilecancel,
      "locusAccept",                  (XtActionProc) locusAccept,
      "locusCancel",                  (XtActionProc) locusCancel,
      "locusClear",                   (XtActionProc) locusClear,
      "locusDefine",                  (XtActionProc) locusDefine,
      "locusDelete",                  (XtActionProc) locusDelete,
      "locusDeleteAll",               (XtActionProc) locusDeleteAll,
      "locusDup",                     (XtActionProc) locusDup,
      "locusIgnore",                  (XtActionProc) locusIgnore,
      "locusInfo",                    (XtActionProc) locusInfo,
      "locusPaste",                   (XtActionProc) locusPaste,
      "locusRename",                  (XtActionProc) locusRename,
      "locusShow",                    (XtActionProc) locusShow,
      "movieCommit",                  (XtActionProc) movieCommit,
      "movieDelete",                  (XtActionProc) movieDelete,
      "movieDeleteAll",               (XtActionProc) movieDeleteAll,
      "movieExtract",                 (XtActionProc) movieExtract,
      "movieMoveDown",                (XtActionProc) movieMoveDown,
      "movieMoveToFirst",             (XtActionProc) movieMoveToFirst,
      "movieMoveToLast",              (XtActionProc) movieMoveToLast,
      "movieMoveUp",                  (XtActionProc) movieMoveUp,
      "movieSetTermCond",             (XtActionProc) movieSetTermCond,
      "pastePoints",                  (XtActionProc) pastePoints,
      "patternCancel",                (XtActionProc) patternCancel,
      "popupselectClipsTBL",          (XtActionProc) popupselectClipsTBL,
      "preWriteClipImage",            (XtActionProc) preWriteClipImage,
      "preWriteClipMask",             (XtActionProc) preWriteClipMask,
      "preschedulerWrite",            (XtActionProc) preschedulerWrite,
      "preshapeImportMask",           (XtActionProc) preshapeImportMask,
      "prewriteLocus",                (XtActionProc) prewriteLocus,
      "rePaintBackground",            (XtActionProc) rePaintBackground,
      "reCaptureRootWindow",          (XtActionProc) reCaptureRootWindow,
      "renameClipCancel",             (XtActionProc) renameClipCancel,
      "renameClipOk",                 (XtActionProc) renameClipOk,
      "renameLocusCancel",            (XtActionProc) renameLocusCancel,
      "renameLocusOk",                (XtActionProc) renameLocusOk,
      "renameSchedCancel",            (XtActionProc) renameSchedCancel,
      "renameSchedOk",                (XtActionProc) renameSchedOk,
      "runFreeze",                    (XtActionProc) runFreeze,
      "runReset",                     (XtActionProc) runReset,
      "runReverse",                   (XtActionProc) runReverse,
      "runReverseClip",               (XtActionProc) runReverseClip,
      "runUnfreeze",                  (XtActionProc) runUnfreeze,
      "runUpdate",                    (XtActionProc) runUpdate,
      "savexetfilecancel",            (XtActionProc) savexetfilecancel,
      "schedOutputDrawingArea",       (XtActionProc) schedOutputDrawingArea,
      "schedOutputRoot",              (XtActionProc) schedOutputRoot,
      "schedulerCancel",              (XtActionProc) schedulerCancel,
      "schedulerDelete",              (XtActionProc) schedulerDelete,
      "schedulerDeleteAll",           (XtActionProc) schedulerDeleteAll,
      "schedulerDuplicate",           (XtActionProc) schedulerDuplicate,
      "schedulerEdit",                (XtActionProc) schedulerEdit,
      "schedulerFreeze",              (XtActionProc) schedulerFreeze,
      "schedulerMoveToMovie",         (XtActionProc) schedulerMoveToMovie,
      "schedulerRename",              (XtActionProc) schedulerRename,
      "schedulerReset",               (XtActionProc) schedulerReset,
      "schedulerResetAll",            (XtActionProc) schedulerResetAll,
      "schedulerReverse",             (XtActionProc) schedulerReverse,
      "schedulerReverseAll",          (XtActionProc) schedulerReverseAll,
      "schedulerReverseClip",         (XtActionProc) schedulerReverseClip,
      "schedulerReverseClipAll",      (XtActionProc) schedulerReverseClipAll,
      "schedulerToRootWinAll",        (XtActionProc) schedulerToRootWinAll,   
      "schedulerToDAALL",             (XtActionProc) schedulerToDAALL,
      "schedulerUnfreeze",            (XtActionProc) schedulerUnfreeze,
      "selectthisclip",               (XtActionProc) selectthisclip,
      "setClipStatusNoBoth",          (XtActionProc) setClipStatusNoBoth,
      "setClipStatusNoImage",         (XtActionProc) setClipStatusNoImage,
      "setClipStatusNoMask",          (XtActionProc) setClipStatusNoMask,
      "setClipStatusNormal",          (XtActionProc) setClipStatusNormal,
      "setFalseToasyncResult",        (XtActionProc) setFalseToasyncResult,
      "setTrueToasyncResult",         (XtActionProc) setTrueToasyncResult,
      "setclipAttributes",            (XtActionProc) setclipAttributes,
      "shapeCancel",                  (XtActionProc) shapeCancel,
      "shapeDoit",                    (XtActionProc) shapeDoit,
      "shapeImportMask",              (XtActionProc) shapeImportMask,
      "shapeImportMaskCancel",        (XtActionProc) shapeImportMaskCancel,
      "spoolerClose",                 (XtActionProc) spoolerClose,
      "spoolerDelete",                (XtActionProc) spoolerDelete,
      "spoolerDeleteAll",             (XtActionProc) spoolerDeleteAll,
      "spoolerMoveDown",              (XtActionProc) spoolerMoveDown,
      "spoolerMoveUp",                (XtActionProc) spoolerMoveUp,
      "spoolerResume",                (XtActionProc) spoolerResume,
      "spoolerSuspend",               (XtActionProc) spoolerSuspend,
      "textCancel",                   (XtActionProc) textCancel,
      "textDoit",                     (XtActionProc) textDoit,
      "unfreezeLogo",                 (XtActionProc) unfreezeLogo,
      "unfreezeMotion",               (XtActionProc) unfreezeMotion,
      "writeClipImage",               (XtActionProc) writeClipImage,
      "writeClipImageCancel",         (XtActionProc) writeClipImageCancel,
      "writeClipMask",                (XtActionProc) writeClipMask,
      "writeClipMaskCancel",          (XtActionProc) writeClipMaskCancel,
      "writeCmapFileAs",              (XtActionProc) writeCmapFileAs,
      "writeLocus",                   (XtActionProc) writeLocus,
      "writeLocusCancel",             (XtActionProc) writeLocusCancel,
      "writeOutXetFileAs",            (XtActionProc) writeOutXetFileAs,
      "writeScheduler",               (XtActionProc) writeScheduler,
      "writeSchedulerCancel",         (XtActionProc) writeSchedulerCancel,
      "xetHelpBuild",                 (XtActionProc) xetHelpBuild,
      "xetHelpColor",                 (XtActionProc) xetHelpColor,
      "xetHelpDemo",                  (XtActionProc) xetHelpDemo,
      "xetHelpFile",                  (XtActionProc) xetHelpFile,
      "xetHelpGeneral",               (XtActionProc) xetHelpGeneral,
      "xetHelpMisc",                  (XtActionProc) xetHelpMisc,
      "xetHelpOverview",              (XtActionProc) xetHelpOverview,
      "xetHelpPlay",                  (XtActionProc) xetHelpPlay,
      "xetHelpSyntax",                (XtActionProc) xetHelpSyntax,
    };

void WCLInterpreter::RegisterActions()
{
  XtAppAddActions(app,ActionPool,XtNumber(ActionPool));
}

void WCLInterpreter::RegisterCallbacks()
{
  
  WcRegisterCallback(app,"XetAction",
		     (XtCallbackProc) actionDispatcher,
		     (caddr_t) this);

  WcRegisterCallback(app,"XetMakeWidgetOval",
		     (XtCallbackProc) makeWidgetOval,
		     (caddr_t) this);
}
