//
//  Xet - X Entertainment (a tool to create animated images)
//
//
//  Author:   Ko-Haw Nieh & Coalition Software, (nieh@netcom.com)
//
//
//  Copyright 1992, 1993 by Ko-Haw Nieh & Coalition Software
//
// Permission to use, copy, and distribute for non-commercial purposes,
// is hereby granted without fee, providing that the above copyright
// notice appear in all copies and that both the copyright notice and this
// permission notice appear in supporting documentation. 
//
// This software is provided as-is and without any warranty of any kind.

#include "run_blink.h"
#include "util.h"
#include <libc.h>
#include "config.h"

RunBlink::RunBlink(Display *d,OutputWindow *w,ClipList *im)
     :RunBase(d,w,im,Blink_E),blinkingStatus(0)
{
}

RunBlink::~RunBlink(){
  if(clipList) delete clipList;
  if(name) delete name;
  if(intervalXid != 0){
    XtRemoveTimeOut(intervalXid);
    intervalXid = 0;
  }
}

RunBase *RunBlink::Copy(){
  RunBlink *rb = new RunBlink(*this);
  rb->clipList = new ClipList(*clipList);
  STRCPY(rb->name,name);
  return rb;
}

void RunBlink::writeToDisk(FILE *fp){
  if(fp){
    fprintf(fp,"blink:");
    clipList->writeOut(fp);
    fprintf(fp,":%s:%d:%d:%d",
	    trailingModeInString(trailingMode),
	    start_x,start_y,
	    interval);
    writeOutTermCond(fp);
    fprintf(fp,"\n");
  }
}

void RunBlink::start(int x, int y, int dx, int dy){
  start_x = current_x = x;
  start_y = current_y = y;
  start_dx = d_x = dx;
  start_dy = d_y = dy;
  clipList->reset();
}

void RunBlink::reset(){
  resetTerminationCond();
  current_x = start_x;
  current_y = start_y;
  d_x = start_dx;
  d_y = start_dy;
  clipList->reset();
}

int RunBlink::nextMove(){
  if(shouldTerminate() == 1){
    takeCareOfOldLocation(current_x,current_y);
    return 1;
  }
  d_x = d_y = 0;
  blinkingStatus = (blinkingStatus) == 0 ? 1 : 0;
  if(blinkingStatus == 1)
    setNextClip();
  jump(blinkingStatus);
  if(shouldTerminate() == 1){
    return 1;
  }
  if(blinkingStatus == 1)
    clip->DisplayImage(drawingArea, current_x, current_y);
  return 0;
}
