//
//  Xet - X Entertainment (a tool to create animated images)
//
//
//  Author:   Ko-Haw Nieh & Coalition Software, (nieh@netcom.com)
//
//
//  Copyright 1992, 1993 by Ko-Haw Nieh & Coalition Software
//
// Permission to use, copy, and distribute for non-commercial purposes,
// is hereby granted without fee, providing that the above copyright
// notice appear in all copies and that both the copyright notice and this
// permission notice appear in supporting documentation. 
//
// This software is provided as-is and without any warranty of any kind.

#ifndef RUN_FLY_H
#define RUN_FLY_H

#include "run_base.h"
#include "config.h"

class RunFly : public RunBase {
friend class Xet;
protected:
  Math_Expr     *Xequation;
  Math_Expr     *Yequation;
  int            fly_start_save;
  int            fly_end_save;
  int            fly_incr_save;
  int            fly_current_save;
  int            fly_start;
  int            fly_end;
  int            fly_incr;
  int            fly_current;
  BoundaryMode   boundaryMode;
  Dir            dir; 
public:
  RunFly(Display *d,OutputWindow*w,ClipList *image);
  ~RunFly();
  BoundaryMode	 getBoundaryMode();
  RunBase	*Copy();
  int		 nextMove();
  int		 setFlyEquation(char *Field1,char *Field2,char *Field3);
  int		 setFlyEquationI(char *Field1,char *Field2,int,int,int,int);
  void		 start(int,int,int,int);
  void		 reset();
  void		 reverse();
  void		 setBoundaryMode(BoundaryMode);
  void		 flying();
  void		 writeToDisk(FILE *);
};

#endif
