//
//  Xet - X Entertainment (a tool to create animated images)
//
//
//  Author:   Ko-Haw Nieh & Coalition Software, (nieh@netcom.com)
//
//
//  Copyright 1992, 1993 by Ko-Haw Nieh & Coalition Software
//
// Permission to use, copy, and distribute for non-commercial purposes,
// is hereby granted without fee, providing that the above copyright
// notice appear in all copies and that both the copyright notice and this
// permission notice appear in supporting documentation. 
//
// This software is provided as-is and without any warranty of any kind.

#ifndef RUN_LOCUS_H
#define RUN_LOCUS_H

#include "run_base.h"
#include "config.h"

class RunLocus : public RunBase {
friend class Xet;
protected:
  Dir             dir; 
  BoundaryMode    boundaryMode;
  Locus          *locus;
  int             current;
  int             incr;
  int             trans_x,trans_y;
public:
  RunLocus(Display *d,OutputWindow *w,ClipList *image);
  ~RunLocus();
  BoundaryMode	  getBoundaryMode();
  RunBase	 *Copy();
  int		  nextMove();
  void		  setLocus(Locus *l);
  void		  setTranslation(int x, int y);
  void		  reverse();
  void		  reset();
  void		  start(int,int,int,int);
  void		  setBoundaryMode(BoundaryMode);
  void		  writeToDisk(FILE *);
};

#endif
