//
//  Xet - X Entertainment (a tool to create animated images)
//
//
//  Author:   Ko-Haw Nieh & Coalition Software, (nieh@netcom.com)
//
//
//  Copyright 1992, 1993 by Ko-Haw Nieh & Coalition Software
//
// Permission to use, copy, and distribute for non-commercial purposes,
// is hereby granted without fee, providing that the above copyright
// notice appear in all copies and that both the copyright notice and this
// permission notice appear in supporting documentation. 
//
// This software is provided as-is and without any warranty of any kind.

#ifndef SCHEDULAR_H
#define SCHEDULAR_H

#include <X11/Intrinsic.h>
#include "config.h"
#include "clip.h"
#include "hash.h"
#include "run_base.h"

class Scheduler : public Hash {
protected:
  XtAppContext   app;
  int            dup_index;
  int            noOfObjects;
  RunMovie       *activeMovie;
public:
  Scheduler(XtAppContext app, int size = 10);
  ~Scheduler();
  static    void work(XtPointer xptr, XtIntervalId *i);

  RunBase  *dup(char *);
  RunBase  *findRunObject(char *);
  RunBase  *getOneMovieObject(int which);
  int       MovieCommit(char *);
  int	    get_dup_index()  { return dup_index++; }
  int	    howmanyObjects() { return noOfObjects;}
  int	    howmanyRunning();
  int	    isFrozen(char *);
  int       writeOut(char *fp,char *ro);
  void	    Delete(char *);
  void	    MoveMovieDown(int which);
  void	    MoveMovieToFirst(int which);
  void	    MoveMovieToLast(int which);
  void	    MoveMovieUp(int which);
  void	    MovieDelete(int which);
  void      MovieDeleteAll();
  void	    addObjToMovie(RunBase *);
  void	    addObjToMovie(char *);
  void      addRunObject(char *name, RunBase *c,unsigned long interval,int);
  void      addRunObject(char *name, RunBase *c, int flag);
  void      buildSchedulerXmList(Widget w);
  void      clearEverything();
  void	    deleteActiveMovie();
  void      extractMovieObject(int which);
  void	    freeze();
  void	    freeze(char *);
  void	    renameKey(char *Old, char *New);
  void	    reset();
  void	    reset(char *);
  void	    resume();
  void	    reverse();
  void	    reverse(char *);
  void	    reverseClip();
  void	    reverseClip(char *);
  void      schedulerDeleteAll();
  void      setActiveMovie(RunMovie *);
  void      setOutputWindow(char *,OutputWindow *);
  void      setOutputWindow(OutputWindow *);
  void	    suspend();
  void	    unfreeze();
  void	    unfreeze(char *);
  void	    updateMovieList(Widget w);
  void      writeOut(FILE *fp);

};

#endif

