//
//  Xet - X Entertainment (a tool to create animated images)
//
//
//  Author:   Ko-Haw Nieh & Coalition Software, (nieh@netcom.com)
//
//
//  Copyright 1992, 1993 by Ko-Haw Nieh & Coalition Software
//
// Permission to use, copy, and distribute for non-commercial purposes,
// is hereby granted without fee, providing that the above copyright
// notice appear in all copies and that both the copyright notice and this
// permission notice appear in supporting documentation. 
//
// This software is provided as-is and without any warranty of any kind.

#include <stdio.h>
#include <osfcn.h>
#include <signal.h>

#include "procSpooler.h"
#include "xet.h"
#include "config.h"
#include "util.h"
#include "wrapper.h"

extern Xet   *XET;

void sig_child()
{
  int status;
  ProcEntry *pt;

  int r = wait((wait *)&status);
  insertStringtoInfo("Subprocess terminated with exit status = %d\n",status);
  if(r == -1){
    insertStringtoInfo("Got SIG_CLD signal, but the wait() returns -1 \n");
  }else{
    pt = XET->getProcSpooler()->getCurrentEntry();
    if(pt != NULL && r == pt->pid){
      // register XtAddTimeOut() so the actual reading of ppm file
      // is performed at a safe time
      XET->registerXtAddTimeOut(0,(XtTimerCallbackProc) readImagefileWrap,
				(XtPointer) pt);
    }else{
      insertStringtoInfo("An unscheduled subprocess is terminated or subprocess is killed by someone.\n");
    }
  }
}

