//
//  Xet - X Entertainment (a tool to create animated images)
//
//
//  Author:   Ko-Haw Nieh & Coalition Software, (nieh@netcom.com)
//
//
//  Copyright 1992, 1993 by Ko-Haw Nieh & Coalition Software
//
// Permission to use, copy, and distribute for non-commercial purposes,
// is hereby granted without fee, providing that the above copyright
// notice appear in all copies and that both the copyright notice and this
// permission notice appear in supporting documentation. 
//
// This software is provided as-is and without any warranty of any kind.

#include "solidImage.h"
#include "util.h"

SolidImage::SolidImage(Display *d,Widget w)
     : Clip(d,w)
{
}
SolidImage::~SolidImage() {
  if(image)
    XDestroyImage(image);
  deallocateString();
}
Clip *SolidImage::dup(){
  SolidImage *rtn = new SolidImage(*this);
  rtn->diskFileName  = NULL;
  rtn->shapeFileName = NULL;
  rtn->clipName      = NULL;
  copyto(rtn);
  rtn->RefCounter = 0;
  return rtn;
}
void SolidImage::MakeImage(int w, int h, int pixval,int,int,int){
  int x,y;
  height =  h;
  width  = w;
  if(w <= 0 || h <= 0){
    image = NULL;
    return;
  }
  depth =  DefaultDepth(Dpy, DefaultScreen(Dpy));
  linepad = 8 - (width % 8);
  bit_data = (unsigned char *)new char[((width + linepad) * height) + 1];
  bytesperline = (width + linepad) * depth / 8;
  image = XCreateImage(Dpy, DefaultVisual(Dpy, DefaultScreen(Dpy)), depth,
		       ZPixmap, 0, (char *)bit_data,
		       (width + linepad), height, 8, bytesperline); 
  for(y=0;y<height;y++){
    for(x = 0;x<width ;x++){
      PutPixel(x,y,pixval);
    }
  }
}


