//
//  Xet - X Entertainment (a tool to create animated images)
//
//
//  Author:   Ko-Haw Nieh & Coalition Software, (nieh@netcom.com)
//
//
//  Copyright 1992, 1993 by Ko-Haw Nieh & Coalition Software
//
// Permission to use, copy, and distribute for non-commercial purposes,
// is hereby granted without fee, providing that the above copyright
// notice appear in all copies and that both the copyright notice and this
// permission notice appear in supporting documentation. 
//
// This software is provided as-is and without any warranty of any kind.

#ifndef UTIL_H
#define UTIL_H

#include <X11/Intrinsic.h>
#include <Xm/Xm.h>
#include <Xm/Text.h>
#include <Xm/List.h>
#include <Xm/TextF.h>
#include <libc.h>
#include <ctype.h>

char	*DeleteSelectedItemFromXmList(Widget list);
char	*SkipToNextDigit(char *ptr);
char	*calcEffectiveDirectory(char *filedirectory);
char	*getSource(char *filename);
char	*get_normal_string_from_XmString(XmString cs);
char	*skipDirectoryPath(char *path);
char	*whichItemInXmListIsSelected(Widget list);
int	 DirectoryExist(char *s);
int	 DirectoryExistOrCreate(char *path);
int	 FileReadable(char *s);
int	 isBlankString(char *s);
int	 dontBlockXEvents(XtAppContext app);
int	 getFileLen (int fd);
int	 performAsyncInteraction(Display *Dpy,Widget);
int	 whichLineInXmListIsSelected(Widget list);
void	 FromXmListToTextField(Widget list, Widget Field);
void	 GrabPointer(Widget w);
void	 PutTextInLabelWidget(Widget w,char *s);
void	 PutTextInLabelWidget(Widget w,char *s, char *s1);
void	 PutTextInLabelWidget(Widget w,char *s, char *s1, char *s2);
void	 PutTextInListWidget(Widget w,char *s);
void	 PutTextInListWidget1(Widget w,char *s);
void	 SortString(char **da, int n);
void	 deleteAllItemsOfXmList(Widget w);
void	 deleteItemInXmList(Widget,char *);
void	 insertStringtoInfo(char *);
void	 insertStringtoInfo(char *, char *);
void	 insertStringtoInfo(char *, char *, char *);
void	 insertStringtoInfo(char *, int);
void	 insertTXTText(Widget infoTXT, char *s);
void	 normalCursor(Widget w);
void	 placeToXmListInRightOrder(Widget schedList,char *);
void	 registerGlobalInfoWidget(Widget w);
void	 replaceXmListContent(Widget schedList,char *, char *);
void	 replaceXmListHighlightContent(Widget list,char *from, char *to);
void	 setCrossReverseCursor(Widget w);
void	 setHand2Cursor(Widget w);
void	 writeXimageInPPM(Display *Dpy,char *fileName,XImage *image);

#endif
