//
//  Xet - X Entertainment (a tool to create animated images)
//
//
//  Author:   Ko-Haw Nieh & Coalition Software, (nieh@netcom.com)
//
//
//  Copyright 1992, 1993 by Ko-Haw Nieh & Coalition Software
//
// Permission to use, copy, and distribute for non-commercial purposes,
// is hereby granted without fee, providing that the above copyright
// notice appear in all copies and that both the copyright notice and this
// permission notice appear in supporting documentation. 
//
// This software is provided as-is and without any warranty of any kind.

#include "xet.h"
#include <X11/Xmu/Converters.h>
#include <libc.h>
#include <osfcn.h>
#include "procSpooler.h"
#include "color.h"
#include "clip.h"

extern Color          *currentCmap;
extern Xet            *XET;
extern int             asyncResult;

void setTrueToasyncResult(){
  asyncResult = True;
}

void setFalseToasyncResult(){
  asyncResult = False;
}

void ReadForkResult(XtPointer x,int *fd, XtInputId *xid){
  XET->readForkResult(x,*fd,xid);
}

void readImagefileWrap(XtPointer p, XtIntervalId){
  ProcEntry *pt = (ProcEntry *) p;
  XET->readImagefile(pt->fileName,pt->clipName,pt->flag,NULL);
  XET->getProcSpooler()->finishUpCurrent(pt->fd);

}

void actionDispatcher(Widget w, char *s){
  XET->actionDispatcher(w,s);
}

void makeWidgetOval(Widget , char *s){
  printf("make %s oval\n",s);
  XmuReshapeWidget(XET->nameToWidget(s),XmuShapeOval,0,0);
}

void updateXYLocation(Widget , XtPointer, XEvent *evt, Boolean){
  XET->updatedrawingWhereField(evt);
}

void updateColorPanel(Widget , XtPointer, XEvent *evt, Boolean){
  XET->updateColorPanelFields(evt);
}

void FSBUpdateImportFilename() {  XET->FSBUpdateImportFilename();}
void PaintBackground()         {  XET->rePaintBackground();}
void PaintColorPallet()        {  XET->rePaintColorPallet();}
void PaintXetLogo()            {  XET->rePaintXetLogo();}
void ReInitialize()            {  XET->ReInitialize();}
void bgroundDoit()             {  XET->bgroundDoit();}
void buildClipList()           {  XET->buildClipList();}
void buildSchedulerList()      {  XET->buildSchedulerList(NULL);}
void buildSpoolList()          {  XET->buildSpoolList();}
void cleaninfotxt()            {  XET->cleaninfotxt();}
void clearDrawingArea()        {  XET->clearDrawingArea();}
void clipAttribApply()         {  XET->clipAttribApply();}
void clipSave()                {  XET->cliprehearse(2);}
void cliprehearse()            {  XET->cliprehearse(1);}
void clipstoprehearse()        {  XET->clipstoprehearse();}
void cmapfilenameTBL()         {  XET->cmapfilenameTBL();}
void colorFreeCells()          {  XET->colorFreeCells();}
void colorSelPastebg()         {  XET->colorSelPaste(1);}
void colorSelPastefg()         {  XET->colorSelPaste(2);}
void colorSelectPanel()        {  XET->colorSelectPanel();}
void configClipsClone()        {  XET->configClipsClone();}
void configClipsDelete()       {  XET->configClipsDelete();}
void configClipsDeleteAll()    {  XET->configClipsDeleteAll();}
void configClipsDeleteMask()   {  XET->configClipsDeleteMask();}
void configClipsDup()          {  XET->configClipsDup();}
void configClipsInfo()         {  XET->configClipsInfo(NULL);}
void configClipsQuantize()     {  XET->configClipsQuantize();}
void configClipsRename()       {  XET->configClipsRename();}
void configClipsSetStatus()    {  XET->configClipsSetStatus();}
void configClipsShow()         {  XET->configClipsShow();}
void configClipsShowAll()      {  XET->configClipsShowAll();}
void configENV()               {  XET->configENV();}
void configENVApply()          {  XET->configENVApply();}
void corpbgArea()              {  XET->cropEntireBackground();}
void cropArea()                {  XET->cropTheArea();}
void destroyBackground()       {  XET->destroyBackground();}
void drawGrid10()              {  XET->drawGrid(10);}
void drawGrid100()             {  XET->drawGrid(100);}
void drawGrid20()              {  XET->drawGrid(20);}
void drawGrid200()             {  XET->drawGrid(200);}
void drawGrid5()               {  XET->drawGrid(5);}
void drawGrid50()              {  XET->drawGrid(50);}
void dumpinfotxt()             {  XET->dumpinfotxt();}
void editLocusAccept()         {  XET->editLocusAccept();}
void editLocusPoints()         {  XET->editLocusPoints();}
void editLocusUnique()         {  XET->editLocusUnique();}
void forgeApply()              {  XET->forgeApply();}
void freezeLogo()              {  XET->freezeLogo();}
void freezeMotion()            {  XET->freezeMotion();}
void imporFlip_trotate270()    {  XET->setFlipOrientation("trotate270");}
void importDoit()              {  XET->importDoit();}
void importFlip_leftright()    {  XET->setFlipOrientation("leftright");}
void importFlip_rotate180()    {  XET->setFlipOrientation("rotate180");}
void importFlip_rotate90()     {  XET->setFlipOrientation("rotate90");}
void importFlip_topbottom()    {  XET->setFlipOrientation("topbottom");}
void importFlip_transpose()    {  XET->setFlipOrientation("transpose");}
void importfetchinfo()         {  XET->importfetchinfo();}
void loadcmap()                {  XET->loadcmap();}
void loadlocus()               {  XET->loadlocus();}
void loadxetfile()             {  XET->loadxetfile();}
void locusAccept()             {  XET->locusAccept();}
void locusCancel()             {  XET->locusCancel();}
void locusClear()              {  XET->locusClear();}
void locusDefine()             {  XET->locusDefine();}
void locusDelete()             {  XET->locusDelete();}
void locusDeleteAll()          {  XET->locusDeleteAll();}
void locusDup()                {  XET->locusDup();}
void locusIgnore()             {  XET->locusIgnore();}
void locusInfo()               {  XET->locusInfo(NULL);}
void locusPaste()              {  XET->locusPaste();}
void locusRename()             {  XET->locusRename();}
void locusShow()               {  XET->locusShow();}
void movieCommit()             {  XET->movieCommit();}
void movieDelete()             {  XET->movieDelete();}
void movieDeleteAll()          {  XET->movieDeleteAll();}
void movieExtract()            {  XET->movieExtract();}
void movieMoveDown()           {  XET->movieMoveDown();}
void movieMoveToFirst()        {  XET->movieMoveToFirst();}
void movieMoveToLast()         {  XET->movieMoveToLast();}
void movieMoveUp()             {  XET->movieMoveUp();}
void movieSetTermCond()        {  XET->schedulerEdit(1);}
void pastePoints()             {  XET->pastePoints();}
void popupselectClipsTBL()     {  XET->popupselectClipsTBL();}
void preWriteClipImage()       {  XET->preWriteClipImage();}
void preWriteClipMask()        {  XET->preWriteClipMask();}
void preschedulerWrite()       {  XET->preschedulerWrite();}
void preshapeImportMask()      {  XET->preshapeImportMask();}
void prewriteLocus()           {  XET->prewriteLocus();}
void rePaintBackground()       {  XET->rePaintBackground();}
void reCaptureRootWindow()     {  XET->reCaptureRootWindow();}
void renameClipOk()            {  XET->renameClipOk();}
void renameLocusOk()           {  XET->renameLocusOk();}
void renameSchedOk()           {  XET->renameSchedOk();}
void resizeDrawingArea()       {  XET->getCurrentDrawingAreaGeometry();}
void runFreeze()               {  XET->runFreeze();}
void runReset()                {  XET->runReset();}
void runReverse()              {  XET->runReverse();}
void runReverseClip()          {  XET->runReverseClip();}
void runUnfreeze()             {  XET->runUnfreeze();}
void runUpdate()               {  XET->runUpdate();}
void schedOutputDrawingArea()  {  XET->schedOutputDrawingArea();}
void schedOutputRoot()         {  XET->schedOutputRoot();}
void schedulerDelete()         {  XET->schedulerDelete();}
void schedulerDeleteAll()      {  XET->schedulerDeleteAllItems();}
void schedulerDuplicate()      {  XET->schedulerDuplicate();}
void schedulerEdit()           {  XET->schedulerEdit();}
void schedulerFreeze()         {  XET->schedulerFreeze();}
void schedulerMoveToMovie()    {  XET->schedulerMoveToMovie();}
void schedulerRename()         {  XET->schedulerRename();}
void schedulerReset()          {  XET->schedulerReset();}
void schedulerResetAll()       {  XET->schedulerResetAll();}
void schedulerReverse()        {  XET->schedulerReverse();}
void schedulerReverseAll()     {  XET->schedulerReverseAll();}
void schedulerReverseClip()    {  XET->schedulerReverseClip();}
void schedulerReverseClipAll() {  XET->schedulerReverseClipAll();}
void schedulerUnfreeze()       {  XET->schedulerUnfreeze();}
void schedulerToRootWinAll()   {  XET->schedulerToRootWinAll();}
void schedulerToDAALL()        {  XET->schedulerToDAALL();}
void selectthisclip()          {  XET->selectthisclip();}
void setClipStatusNoBoth()     {  XET->setClipStatus(IGNOREBOTH_E);}
void setClipStatusNoImage()    {  XET->setClipStatus(IGNOREIMAGE_E);}
void setClipStatusNoMask()     {  XET->setClipStatus(IGNOREMASK_E);}
void setClipStatusNormal()     {  XET->setClipStatus(NORMAL_E);}
void setclipAttributes()       {  XET->setclipAttributes();}
void shapeDoit()               {  XET->shapeDoit();}
void shapeImportMask()         {  XET->shapeImportMask();}
void spoolerClose()            {  XET->spoolerClose();}
void spoolerDelete()           {  XET->spoolerDelete();}
void spoolerDeleteAll()        {  XET->spoolerDeleteAll();}
void spoolerMoveDown()         {  XET->spoolerMoveDown();}
void spoolerMoveUp()           {  XET->spoolerMoveUp();}
void spoolerResume()           {  XET->spoolerResume();}
void spoolerSuspend()          {  XET->spoolerSuspend();}
void textDoit()                {  XET->textDoit();}
void unfreezeLogo()            {  XET->unfreezeLogo();}
void unfreezeMotion()          {  XET->unfreezeMotion();}
void writeClipImage()          {  XET->writeClipImage();}
void writeClipMask()           {  XET->writeClipMask();}
void writeCmapFileAs()         {  XET->writeCmapFileAs();}
void writeLocus()              {  XET->writeLocus();}
void writeOutXetFileAs()       {  XET->writeOutXetFileAs();}
void writeScheduler()          {  XET->writeScheduler();}
void xetHelpBuild()            {  XET->xetHelp("build.hlp");}
void xetHelpColor()            {  XET->xetHelp("color.hlp");}
void xetHelpDemo()             {  XET->xetHelp("demo.hlp");}
void xetHelpFile()             {  XET->xetHelp("file.hlp");}
void xetHelpGeneral()          {  XET->xetHelp("general.hlp");}
void xetHelpMisc()             {  XET->xetHelp("misc.hlp");}
void xetHelpOverview()         {  XET->xetHelp("overview.hlp");}
void xetHelpPlay()             {  XET->xetHelp("play.hlp");}
void xetHelpSyntax()           {  XET->xetHelp("syntax.hlp");}

///////////////////////////////

void FSBCancel(){
  XET->genericCancel("importTBL*importImgimagePB");
  XET->genericCancel("importTBL*importCancel");
}
void schedulerCancel(){
  XET->genericCancel("*scheduler");
  XET->getScheduler()->deleteActiveMovie();
}

void bgroundCancel()        {  XET->genericCancel("*bground1");}
void clipAttribCancel()     {  XET->genericCancel("configClipsTBL*configClipsAttribute");}
void clipCancel()           {  XET->genericCancel("*animationSetup");}
void cmapfilenameCancel()   {  XET->genericCancel("*colorSave");}
void colorSelCancel()       {  XET->genericCancel("*colorSelPanel");}
void configClipsCancel()    {  XET->genericCancel("*configClips");}
void configENVCancel()      {  XET->genericCancel("*config");}
void corpCancel()           {  XET->genericCancel("*snapShot");}
void fileNameCancel()       {  XET->genericCancel("*saveFileAs");}
void forgeCancel()          {  XET->genericCancel("*forge");}
void importCancel()         {  XET->genericCancel("*importClip");}
void loadcmapCancel()       {  XET->genericCancel("*colorLoad");}
void loadlocusCancel()      {  XET->genericCancel("locusTBL*locusRead");}
void loadxetfilecancel()    {  XET->genericCancel("*loadFile");}
void patternCancel()        {  XET->genericCancel("*pattern");}
void renameClipCancel()     {  XET->genericCancel("configClipsTBL*configClipsRename");}
void renameLocusCancel()    {  XET->genericCancel("locusTBL*locusRename");}
void renameSchedCancel()    {  XET->genericCancel("schedulerTBL*schedulerRename");}
void savexetfilecancel()    {  XET->genericCancel("*saveFile");}
void shapeCancel()          {  XET->genericCancel("*shape");}
void shapeImportMaskCancel(){  XET->genericCancel("shapeTBL*shapeImport");}
void textCancel()           {  XET->genericCancel("*string");}
void writeClipImageCancel() {  XET->genericCancel("configClipsTBL*configClipsWriteClip");}
void writeClipMaskCancel()  {  XET->genericCancel("configClipsTBL*configClipsWriteMask");}
void writeLocusCancel()     {  XET->genericCancel("locusTBL*locusWrite");}
void writeSchedulerCancel() {  XET->genericCancel("schedulerTBL*schedulerWrite");}
