//
//  Xet - X Entertainment (a tool to create animated images)
//
//
//  Author:   Ko-Haw Nieh & Coalition Software, (nieh@netcom.com)
//
//
//  Copyright 1992, 1993 by Ko-Haw Nieh & Coalition Software
//
// Permission to use, copy, and distribute for non-commercial purposes,
// is hereby granted without fee, providing that the above copyright
// notice appear in all copies and that both the copyright notice and this
// permission notice appear in supporting documentation. 
//
// This software is provided as-is and without any warranty of any kind.

#include <stdlib.h>
#include <sys/types.h>
#include <sys/time.h>
#include "config.h"
#include "xet.h"
#include <libc.h>
#include <math.h>
#include <osfcn.h>
#include <string.h>
#include <Xm/Xm.h>
#include <Xm/Text.h>
#include <Xm/TextF.h>
#include <Xm/ToggleB.h>
#include "util.h"

extern  int             asyncResult;

void Xet::shapeDoit(){
  Widget shapebackgroundimageTF = nameToWidget("shapeTBL*shapebackgroundimageTF");
  Widget shapesourceYTF = nameToWidget("shapeTBL*shapesourceYTF");
  Widget shapesourceXTF = nameToWidget("shapeTBL*shapesourceXTF");
  Widget shapeField1TF  = nameToWidget("shapeTBL*shapeField1TF");
  Widget shapeField2TF  = nameToWidget("shapeTBL*shapeField2TF");
  Widget shapeField3TF  = nameToWidget("shapeTBL*shapeField3TF");
  Widget shapeField4TF  = nameToWidget("shapeTBL*shapeField4TF");
  Widget shapeField5TF  = nameToWidget("shapeTBL*shapeField5TF");
  Widget shapeField6TF  = nameToWidget("shapeTBL*shapeField6TF");
  
  char *shapebackgroundimage = XmTextFieldGetString(shapebackgroundimageTF);
  char *shapesourceY = XmTextFieldGetString(shapesourceYTF);
  char *shapesourceX = XmTextFieldGetString(shapesourceXTF);
  char *shapeField1  = XmTextFieldGetString(shapeField1TF);
  char *shapeField2  = XmTextFieldGetString(shapeField2TF);
  char *shapeField3  = XmTextFieldGetString(shapeField3TF);
  char *shapeField4  = XmTextFieldGetString(shapeField4TF);
  char *shapeField5  = XmTextFieldGetString(shapeField5TF);
  char *shapeField6  = XmTextFieldGetString(shapeField6TF);
  
  ShapeMode shapeMode;
  Widget solid  = nameToWidget("shapeTBL*shapeModeRadioBox.lt");
  Widget hollow = nameToWidget("shapeTBL*shapeModeRadioBox.mt");
  if(XmToggleButtonGetState(solid))    shapeMode = SOLID_E;
  if(XmToggleButtonGetState(hollow))   shapeMode = HOLLOW_E;

  ShapeType shapeType;
  Widget circle        = nameToWidget("shapeTBL*shapeShapeRadioBox.lt");
  Widget ellipse       = nameToWidget("shapeTBL*shapeShapeRadioBox.mt");
  Widget rectangular   = nameToWidget("shapeTBL*shapeShapeRadioBox.rt");
  Widget star          = nameToWidget("shapeTBL*shapeShapeRadioBox.lm");
  Widget gear          = nameToWidget("shapeTBL*shapeShapeRadioBox.mm");
  Widget spray         = nameToWidget("shapeTBL*shapeShapeRadioBox.bt");
  Widget mesh          = nameToWidget("shapeTBL*shapeShapeRadioBox.rm"); 
  Widget diagonal      = nameToWidget("shapeTBL*shapeShapeRadioBox.rb");
  Widget polygon       = nameToWidget("shapeTBL*shapeShapeRadioBox.mb");

  if(XmToggleButtonGetState(circle))          shapeType = CIRCLE_E;      
  if(XmToggleButtonGetState(ellipse))         shapeType = ELLIPSE_E;        
  if(XmToggleButtonGetState(rectangular))     shapeType = RECTANGULAR_E; 
  if(XmToggleButtonGetState(star))            shapeType = STAR_E;       
  if(XmToggleButtonGetState(gear))            shapeType = GEAR_E;      
  if(XmToggleButtonGetState(spray))           shapeType = SPRAY_E;      
  if(XmToggleButtonGetState(mesh))            shapeType = MESH_E;  
  if(XmToggleButtonGetState(diagonal))        shapeType = DIAGONAL_E;    
  if(XmToggleButtonGetState(polygon))         shapeType = POLYGON_ES_E;
  Clip *clp;
  if(strcmp("",shapebackgroundimage) == 0){
    popupModalInfoBox("Must specify a clip name\n");
    goto D99;
  }else{
    clp = clipsPool->findClip(shapebackgroundimage);
    if(clp == NULL){
      popupModalInfoBox("Clip <%s> not found\n",shapebackgroundimage);
      goto D99;
    }
  }
  double pcnt;
  int    radius_x,radius_y,x_orig,y_orig;
  int    oslx,islx,osly,isly,nos,angle;
  Pixmap pix;
  Widget areYouSureTBL;
  int rtn;
  switch(shapeType){
  case ELLIPSE_E:
  case CIRCLE_E:
    radius_x = atoi(shapeField1);
    if(shapeType == CIRCLE_E)
      radius_y = radius_x;
    else
      radius_y = atoi(shapeField2);
    x_orig = atoi(shapesourceX);
    y_orig = atoi(shapesourceY);
    pix = creatArcMask(clp->Width(),clp->Height(),x_orig,y_orig,
		       radius_x,radius_y,shapeMode);
    break;        
  case RECTANGULAR_E:
    radius_x = atoi(shapeField1);
    radius_y = atoi(shapeField2);
    x_orig = atoi(shapesourceX);
    y_orig = atoi(shapesourceY);
    pix = creatRectMask(clp->Width(),clp->Height(),x_orig,y_orig,
			radius_x,radius_y,shapeMode);
    break; 
  case STAR_E:
    oslx = atoi(shapeField1);
    osly = atoi(shapeField2);
    islx = atoi(shapeField3);
    isly = atoi(shapeField4);
    nos = atoi(shapeField5);
    angle = atoi(shapeField6);
    x_orig = atoi(shapesourceX);
    y_orig = atoi(shapesourceY);
    pix = creatStarMask(clp->Width(),clp->Height(),x_orig,y_orig,
			oslx,osly,islx,isly,nos,angle,shapeMode);
   
    break;       
  case GEAR_E:
    oslx = atoi(shapeField1);
    osly = atoi(shapeField2);
    islx = atoi(shapeField3);
    isly = atoi(shapeField4);
    nos = atoi(shapeField5);
    angle = atoi(shapeField6);
    x_orig = atoi(shapesourceX);
    y_orig = atoi(shapesourceY);
    pix = creatGearMask(clp->Width(),clp->Height(),x_orig,y_orig,
			oslx,osly,islx,isly,nos,angle,shapeMode);

    break; 
  case SPRAY_E:
    x_orig = atoi(shapesourceX);
    pcnt = atof(shapesourceY);
    pix = creatSprayMask(clp->Width(),clp->Height(),pcnt,x_orig,shapeMode);
    break;
  case MESH_E:
    oslx = atoi(shapeField1);
    osly = atoi(shapeField2);
    islx = atoi(shapeField3);
    isly = atoi(shapeField4);
    angle = atoi(shapeField5);
    x_orig = atoi(shapesourceX);
    y_orig = atoi(shapesourceY);
    if(angle >= 0 && angle < 90){
      // for some reason oslx and osly is reversed, islx and isly is also
      // reverse, instead of changing the creatMeshMask code I simply changed
      // the order of the oslx/osly and islx/isly.
      pix = creatMeshMask(clp->Width(),clp->Height(),x_orig,y_orig,
			  osly,oslx,isly,islx,angle,shapeMode);
    }else{
      popupModalInfoBox("Orientation angle must be between 0 and 90 degree");
      goto D99;
    }
    break;  
  case DIAGONAL_E:
    x_orig = atoi(shapesourceX);
    y_orig = atoi(shapesourceY);
    angle = atoi(shapeField1);
    islx = atoi(shapeField2);
    if(angle <= 180 && angle >= 0){
      switch(angle){
      case 90:
	pix = creatRectMask(clp->Width(),clp->Height(),x_orig,y_orig,
			    islx * 2,clp->Height(),shapeMode);
	break;
      case 0:
      case 180:
	pix = creatRectMask(clp->Width(),clp->Height(),x_orig,y_orig,
			    clp->Width(),islx * 2,shapeMode);
	break;
      default:
	pix = creatDiagonalMask(clp->Width(),clp->Height(),x_orig,y_orig,
				angle,islx,shapeMode);
	break;
      }
    }else{
      popupModalInfoBox("Orientation angle must be between 0 and 180 degree");
      goto D99;
    }
    break;    
  case POLYGON_ES_E:
    oslx = atoi(shapeField1);
    islx = atoi(shapeField2);
    nos = atoi(shapeField3);
    angle = atoi(shapeField4);
    x_orig = atoi(shapesourceX);
    y_orig = atoi(shapesourceY);
    pix = creatPolygonMask(clp->Width(),clp->Height(),x_orig,y_orig,oslx,
			   islx,nos,angle,shapeMode);
    break;
  }
  if(clp->getShapeMask()){
    areYouSureTBL = createAreYouSureDialog("Clip already has a shape mask, replace it,  Are you sure ?");
    rtn = performAsyncInteraction(Dpy,areYouSureTBL);
    if(rtn){
      clp->setShapeMask(pix);
      insertStringtoInfo("Mask is attached to clip <%s>\n",shapebackgroundimage);
    }else{
      insertStringtoInfo("Mask is not attached to clip <%s>\n",shapebackgroundimage);
    }
    destroyAreYouSureDialog();
  }else{
    clp->setShapeMask(pix);
    insertStringtoInfo("Mask is attached to clip <%s>\n",shapebackgroundimage);
  }

  XFreePixmap(Dpy,pix);
 D99:
  XtFree(shapebackgroundimage);
  XtFree(shapesourceY);
  XtFree(shapesourceX);
  XtFree(shapeField2);
  XtFree(shapeField1);
}

Pixmap Xet::creatRectMask(int width, int height,int x_orig,int y_orig,
			  int radius_x,int radius_y, ShapeMode shapeMode)
{
  GC            loc_gc;
  XGCValues     gvals;
  Pixmap pix;
  pix = XCreatePixmap(Dpy,drawingArea->window,width,height,1);
  loc_gc = XCreateGC(Dpy,pix, 0, &gvals);
  XSetForeground(Dpy,loc_gc,WhitePixel(Dpy,DefaultScreen(Dpy)));
  XFillRectangle(Dpy,pix,loc_gc,0,0,width,height);
  XSetForeground(Dpy,loc_gc,BlackPixel(Dpy,DefaultScreen(Dpy)));
  XSetBackground(Dpy,loc_gc,WhitePixel(Dpy,DefaultScreen(Dpy)));
  if(shapeMode == SOLID_E){
    XSetFunction(Dpy,loc_gc,GXcopy);
  }else{
    XFillRectangle(Dpy,pix,loc_gc,0,0,width,height);
    XSetFunction(Dpy,loc_gc,GXcopyInverted);
  }
  XFillRectangle(Dpy,pix,loc_gc,x_orig - radius_x/2,
		 y_orig - radius_y/2 ,radius_x,radius_y);
  XFreeGC(Dpy,loc_gc);
  char khn[256];
  sprintf(khn,"Build rectangular clip mask at orig = (%d, %d) width = %d height = %d\n",
	  x_orig,y_orig,radius_x, radius_y);
  insertStringtoInfo(khn);
  return pix;
}

Pixmap Xet::creatArcMask(int width, int height,int x_orig,int y_orig,
			 int radius_x,int radius_y, ShapeMode shapeMode)
{
  GC            loc_gc;
  XGCValues     gvals; 
  Pixmap pix = XCreatePixmap(Dpy,drawingArea->window,width,height,1);
  loc_gc = XCreateGC(Dpy,pix, 0, &gvals);
  XSetForeground(Dpy,loc_gc,WhitePixel(Dpy,DefaultScreen(Dpy)));
  XFillRectangle(Dpy,pix,loc_gc,0,0,width,height);
  XSetForeground(Dpy,loc_gc,BlackPixel(Dpy,DefaultScreen(Dpy)));
  XSetBackground(Dpy,loc_gc,WhitePixel(Dpy,DefaultScreen(Dpy)));

  if(shapeMode == SOLID_E){
    XSetFunction(Dpy,loc_gc,GXcopy);
  }else{
    XFillRectangle(Dpy,pix,loc_gc,0,0,width,height);
    XSetFunction(Dpy,loc_gc,GXcopyInverted);
  }
  XFillArc(Dpy,pix,loc_gc,x_orig - radius_x,
	   y_orig - radius_y ,radius_x*2,radius_y*2,0,360*64);
  XFreeGC(Dpy,loc_gc);
  char khn[256];
  sprintf(khn,"Build circle/ellipse clip mask at orig = (%d, %d) radius_x = %d radius_y = %d\n",
	  x_orig,y_orig,radius_x, radius_y);
  insertStringtoInfo(khn);
  return pix;
}

Pixmap  Xet::creatStarMask(int width, int height,
			   int x_orig,int y_orig,
			   int longspikex,int longspikey,
			   int shortspikex,int shortspikey,
			   int nos,int angle, ShapeMode shapeMode)
{
  GC            loc_gc;
  XGCValues     gvals; 
  Pixmap pix = XCreatePixmap(Dpy,drawingArea->window,width,height,1);
  loc_gc = XCreateGC(Dpy,pix, 0, &gvals);
  XSetForeground(Dpy,loc_gc,WhitePixel(Dpy,DefaultScreen(Dpy)));
  XFillRectangle(Dpy,pix,loc_gc,0,0,width,height);
  XSetForeground(Dpy,loc_gc,BlackPixel(Dpy,DefaultScreen(Dpy)));
  XSetBackground(Dpy,loc_gc,WhitePixel(Dpy,DefaultScreen(Dpy)));
  
  if(shapeMode == SOLID_E){
    XSetFunction(Dpy,loc_gc,GXcopy);
  }else{
    XFillRectangle(Dpy,pix,loc_gc,0,0,width,height);
    XSetFunction(Dpy,loc_gc,GXcopyInverted);
  }
  int i,j;
  int npoints = nos * 2;
  XPoint *points = new XPoint[npoints];
  double ang = 360.0 / npoints;
  for(i = j = 0;i < nos;i++){
    points[j].x = (short) (x_orig + longspikex * cos(0.0175*(j*ang+angle)));
    points[j].y = (short) (y_orig + longspikey * sin(0.0175*(j*ang+angle)));
    j++;
    points[j].x = (short) (x_orig + shortspikex * cos(0.0175*(j*ang+angle)));
    points[j].y = (short) (y_orig + shortspikey * sin(0.0175*(j*ang+angle)));
    j++;
  }
  XFillPolygon(Dpy,pix,loc_gc,points,npoints,Nonconvex,CoordModeOrigin);
  XFreeGC(Dpy,loc_gc);
  delete points;
  char khn[256];
  sprintf(khn,"Build star clip mask at orig = (%d, %d) spike length = (%d %d) spike bottom = (%d %d) no. of spikes = %d angle = %d\n",
	  x_orig,y_orig,longspikex,longspikey,
	  shortspikex, shortspikey,
	  nos, angle);
  insertStringtoInfo(khn);
  return pix; 
}

Pixmap  Xet::creatPolygonMask(int width, int height,
			   int x_orig,int y_orig,
			   int radius_x,int radius_y,
			   int nos,int angle, ShapeMode shapeMode)
{
  GC            loc_gc;
  XGCValues     gvals; 
  Pixmap pix = XCreatePixmap(Dpy,drawingArea->window,width,height,1);
  loc_gc = XCreateGC(Dpy,pix, 0, &gvals);
  XSetForeground(Dpy,loc_gc,WhitePixel(Dpy,DefaultScreen(Dpy)));
  XFillRectangle(Dpy,pix,loc_gc,0,0,width,height);
  XSetForeground(Dpy,loc_gc,BlackPixel(Dpy,DefaultScreen(Dpy)));
  XSetBackground(Dpy,loc_gc,WhitePixel(Dpy,DefaultScreen(Dpy)));
  
  if(shapeMode == SOLID_E){
    XSetFunction(Dpy,loc_gc,GXcopy);
  }else{
    XFillRectangle(Dpy,pix,loc_gc,0,0,width,height);
    XSetFunction(Dpy,loc_gc,GXcopyInverted);
  }
  int i,j;
  int npoints = nos;
  XPoint *points = new XPoint[npoints];
  double ang = 360.0 / npoints;
  for(i = j = 0;i < nos;i++){
    points[j].x = (short) (x_orig + radius_x * cos(0.0175*(j*ang+angle)));
    points[j].y = (short) (y_orig + radius_y * sin(0.0175*(j*ang+angle)));
    j++;
  }
  XFillPolygon(Dpy,pix,loc_gc,points,npoints,Nonconvex,CoordModeOrigin);
  XFreeGC(Dpy,loc_gc);
  delete points;
  char khn[256];
  sprintf(khn,"Build polygon clip mask at orig = (%d, %d) radius_x = %d radius_y = %d no. of sides = %d angle = %d\n",
	  x_orig,y_orig,radius_x, radius_y,nos,angle);
  insertStringtoInfo(khn);
  return pix; 
}

Pixmap  Xet::creatGearMask(int width, int height,
			   int x_orig,int y_orig,
			   int longspikex,int longspikey,
			   int shortspikex,int shortspikey,
			   int nos,int angle, ShapeMode shapeMode)
{
   GC            loc_gc;
  XGCValues     gvals; 
  Pixmap pix = XCreatePixmap(Dpy,drawingArea->window,width,height,1);
  loc_gc = XCreateGC(Dpy,pix, 0, &gvals);
  XSetForeground(Dpy,loc_gc,WhitePixel(Dpy,DefaultScreen(Dpy)));
  XFillRectangle(Dpy,pix,loc_gc,0,0,width,height);
  XSetForeground(Dpy,loc_gc,BlackPixel(Dpy,DefaultScreen(Dpy)));
  XSetBackground(Dpy,loc_gc,WhitePixel(Dpy,DefaultScreen(Dpy)));
  
  if(shapeMode == SOLID_E){
    XSetFunction(Dpy,loc_gc,GXcopy);
  }else{
    XFillRectangle(Dpy,pix,loc_gc,0,0,width,height);
    XSetFunction(Dpy,loc_gc,GXcopyInverted);
  }
  int i,j,k;
  int npoints = nos * 4;
  XPoint *points = new XPoint[npoints];
  double ang = 360.0 / npoints * 2;
  for(i = j = k = 0;i < nos;i++){
    points[j].x = (short) (x_orig + longspikex * cos(0.0175*(k*ang+angle)));
    points[j].y = (short) (y_orig + longspikey * sin(0.0175*(k*ang+angle)));
    j++;k++;
    points[j].x = (short) (x_orig + longspikex * cos(0.0175*(k*ang+angle)));
    points[j].y = (short) (y_orig + longspikey * sin(0.0175*(k*ang+angle)));
    j++;
    points[j].x = (short) (x_orig + shortspikex * cos(0.0175*(k*ang+angle)));
    points[j].y = (short) (y_orig + shortspikey * sin(0.0175*(k*ang+angle)));
    j++;k++;
    points[j].x = (short) (x_orig + shortspikex * cos(0.0175*(k*ang+angle)));
    points[j].y = (short) (y_orig + shortspikey * sin(0.0175*(k*ang+angle)));
    j++;
  }
  XFillPolygon(Dpy,pix,loc_gc,points,npoints,Nonconvex,CoordModeOrigin);
  XFreeGC(Dpy,loc_gc);
  delete points;
  char khn[256];
  sprintf(khn,"Build gear clip mask at orig = (%d, %d) spike length = (%d %d) spike bottom = (%d %d) no. of spikes = %d angle = %d\n",
	  x_orig,y_orig,longspikex,longspikey,
	  shortspikex, shortspikey,
	  nos, angle);
  insertStringtoInfo(khn);
  return pix; 
}

Pixmap Xet::creatSprayMask(int width, int height,double pcnt,int psz,
			   ShapeMode shapeMode)
{
  GC            loc_gc;
  XGCValues     gvals; 
  Pixmap pix = XCreatePixmap(Dpy,drawingArea->window,width,height,1);
  loc_gc = XCreateGC(Dpy,pix, 0, &gvals);
  XSetForeground(Dpy,loc_gc,WhitePixel(Dpy,DefaultScreen(Dpy)));
  XFillRectangle(Dpy,pix,loc_gc,0,0,width,height);
  XSetForeground(Dpy,loc_gc,BlackPixel(Dpy,DefaultScreen(Dpy)));
  XSetBackground(Dpy,loc_gc,WhitePixel(Dpy,DefaultScreen(Dpy)));

  if(shapeMode == SOLID_E){
    XSetFunction(Dpy,loc_gc,GXcopy);
  }else{
    XFillRectangle(Dpy,pix,loc_gc,0,0,width,height);
    XSetFunction(Dpy,loc_gc,GXcopyInverted);
  }
  if(pcnt == 0){
    return pix;
  }
  if(pcnt == 100){
    XFillRectangle(Dpy,pix,loc_gc,0,0,width,height);
    return pix;
  }
  XSetLineAttributes(Dpy,loc_gc,(unsigned int) psz,LineSolid,CapRound,
		     JoinRound);
  //int khn2 = (int) (width * height * pcnt / 100 / psz);
  int khn2 = (int) (width * height * pcnt / 100);
  int i,x,y;
  for(i=0;i<khn2;i++){
    x = (int) ((int)random() % width); 
    y = (int) ((int)random() % height);
    XDrawLine(Dpy,pix,loc_gc,x,y,x,y);
    //XDrawPoint(Dpy,pix,loc_gc,x,y);
  }
  XFreeGC(Dpy,loc_gc);
  char khn[256];
  sprintf(khn,"Build spray clip mask spot size = %d percent of coverage = %f\n",
	  psz,pcnt);
  insertStringtoInfo(khn);
  return pix;
}

static void findTwoDistantPoints(XPoint *p, int d, double angle,
				 XPoint *p1,XPoint *p2)
{
  double  a = d * sin(0.0175*angle);
  double  b = d * cos(0.0175*angle);
  p1->x = p->x - (short)a;
  p1->y = p->y + (short)b;
  p2->x = p->x + (short)a;
  p2->y = p->y - (short)b;
}

static void findIntersectionwOnHorizLine(XPoint *p, double slope, 
					 int y,XPoint *p1)
{
  double b = p->y - p->x * slope;
  p1->y = (short)y;
  p1->x = (short) ((y - b) / slope);
}

static void findIntersectionwOnVertLine(XPoint *p, double slope, 
					int x,XPoint *p1)
{
  double b = p->y - p->x * slope;
  p1->x = (short)x;
  p1->y = (short)(x * slope + b);
}

// find the two intersction points of a line pass point P with angle 
// against box \(0,0,width,height\) if no interection return 0
static int findInteraction(XPoint *p,int width,int height,double angle,
			   XPoint *p1,XPoint *p2)
{
  if(angle == 90){
    p1->x = p->x;
    p1->y = height;
    p2->x = p->x;
    p2->y = 0;
    if(p->x < 0 || p->x > width)
      return 0;
    return 1;
  }
  if(angle == 0){
    p1->x = 0;
    p1->y = p->y;
    p2->x = width;
    p2->y = p->y;
    if(p->y < 0 || p->y > height)
      return 0;
    return 1;
  }
  double slope = tan(0.0175 * angle);
  double b = p->y - p->x * slope;
  if(angle < 90 && angle > 0){
    p1->x = 0;
    p1->y = (short) b;
    p2->x = (short) width;
    p2->y = (short) (width * slope + b);
    if(b < 0){
      findIntersectionwOnHorizLine(p,slope,0,p1);
      if(p1->x > width)
	return 0;
    }
    if(b > height)
      return 0;
    if(p2->y < 0)
      return 0;
    if(p2->y > height){
      findIntersectionwOnHorizLine(p,slope,height,p2);
      if(p2->x > width)
	return 0;
      if(p2->x < 0)
	return 0;
    }
    return 1;
  }
  if(angle > 90){
    p1->x = 0;
    p1->y = (short) b;
    p2->x = (short) width;
    p2->y = (short) (width * slope + b);
    if(b > height){
      findIntersectionwOnHorizLine(p,slope,height,p1);
      if(p1->x > width)
	return 0;
      if(p1->x < 0)
	return 0;
    }
    if(b < 0)
      return 0;
    if(p2->y > height)
      return 0;
    if(p2->y < 0){
      findIntersectionwOnHorizLine(p,slope,0,p2);
      if(p2->x > width)
	return 0;
      if(p2->x < 0)
	return 0;
    }
    return 1;
  }
}

Pixmap Xet::creatDiagonalMask(int width, int height,int x_orig,int y_orig,
			      int angle,int span,
			      ShapeMode shapeMode)
{
  GC            loc_gc;
  XGCValues     gvals; 
  Pixmap pix = XCreatePixmap(Dpy,drawingArea->window,width,height,1);
  loc_gc = XCreateGC(Dpy,pix, 0, &gvals);
  XSetForeground(Dpy,loc_gc,WhitePixel(Dpy,DefaultScreen(Dpy)));
  XFillRectangle(Dpy,pix,loc_gc,0,0,width,height);
  XSetForeground(Dpy,loc_gc,BlackPixel(Dpy,DefaultScreen(Dpy)));
  XSetBackground(Dpy,loc_gc,WhitePixel(Dpy,DefaultScreen(Dpy)));

  if(shapeMode == SOLID_E){
    XSetFunction(Dpy,loc_gc,GXcopy);
  }else{
    XFillRectangle(Dpy,pix,loc_gc,0,0,width,height);
    XSetFunction(Dpy,loc_gc,GXcopyInverted);
  }

  // this is a stupid algotithm, should do this
  // just find out the two end points then draw a fat line on it
  // X server will take care of all clipping problems KoHaw Nieh 10/1/1992
  int npoints;
  // there were be at most 6 vertices
  XPoint *points = new XPoint[6];
  XPoint po,p1,p2,p3,p4,p5,p6;
  po.x = x_orig;
  po.y = y_orig;
  findTwoDistantPoints(&po,span,angle,&p1,&p2);
  double slope = tan(0.0175 * angle);
  findIntersectionwOnHorizLine(&p1,slope,height,&p3);
  findIntersectionwOnHorizLine(&p1,slope,0,&p4);
  findIntersectionwOnHorizLine(&p2,slope,0,&p5);
  findIntersectionwOnHorizLine(&p2,slope,height,&p6);
  if(angle < 90){
    if(p3.x > width)
      findIntersectionwOnVertLine(&p1,slope,width,&p3);
    if(p4.x < 0)
      findIntersectionwOnVertLine(&p1,slope,0,&p4);
    if(p5.x < 0)
      findIntersectionwOnVertLine(&p2,slope,0,&p5);
    if(p6.x > width)
      findIntersectionwOnVertLine(&p2,slope,width,&p6);
    npoints = 0;
    if(p3.x < 0)       p3.x = 0;
    if(p3.x > width)   p3.x = width;
    if(p3.y < 0)       p3.y = 0;
    if(p3.y > height)  p3.y = height;
    points[npoints].x = p3.x;
    points[npoints++].y = height - p3.y;
    if(p4.y < 0)       p4.y = 0;
    if(p4.y > height)  p4.y = height;
    if(p4.x < 0)       p4.x = 0;
    if(p4.x > width)   p4.x = width;
    points[npoints].x = p4.x;
    points[npoints++].y = height - p4.y;
    if(p4.y > 0 && p5.x > 0){
      points[npoints].x = 0;
      points[npoints++].y = height;
    }
    if(p5.x > width)       p5.x = width;
    if(p5.x < 0)           p5.x = 0;
    if(p5.y > height)      p5.x = height;
    if(p5.y < 0)           p5.x = 0;
    points[npoints].x = p5.x;
    points[npoints++].y = height - p5.y;
    if(p6.y > height)       p6.y = height;
    if(p6.y < 0)            p6.y = 0;
    if(p6.x > width)        p6.x = width;
    if(p6.x < 0)            p6.x = 0;
    points[npoints].x = p6.x;
    points[npoints++].y = height - p6.y;
    if(p3.x < width && p6.y < height){
      points[npoints].x = width;
      points[npoints++].y = 0;
    }
  }
  if(angle > 90){
    if(p3.x < 0)
      findIntersectionwOnVertLine(&p1,slope,0,&p3);
    if(p4.x > width)
      findIntersectionwOnVertLine(&p1,slope,width,&p4);
    if(p5.x > width)
      findIntersectionwOnVertLine(&p2,slope,width,&p5);
    if(p6.x < 0)
      findIntersectionwOnVertLine(&p2,slope,0,&p6);
    npoints = 0;
    if(p3.x < 0)       p3.x = 0;
    if(p3.x > width)   p3.x = width;
    if(p3.y < 0)       p3.y = 0;
    if(p3.y > height)  p3.y = height;
    points[npoints].x = p3.x;
    points[npoints++].y = height - p3.y;
    if(p4.y < 0)       p4.y = 0;
    if(p4.y > height)  p4.y = height;
    if(p4.x < 0)       p4.x = 0;
    if(p4.x > width)   p4.x = width;
    points[npoints].x = p4.x;
    points[npoints++].y = height - p4.y;
    if(p5.x < width && p4.y > 0){
      points[npoints].x = width;
      points[npoints++].y = height - 0;
    }
    if(p5.x > width)       p5.x = width;
    if(p5.x < 0)           p5.x = 0;
    if(p5.y > height)      p5.x = height;
    if(p5.y < 0)           p5.x = 0;
    points[npoints].x = p5.x;
    points[npoints++].y = height - p5.y;
    if(p6.y > height)       p6.y = height;
    if(p6.y < 0)            p6.y = 0;
    if(p6.x > width)        p6.x = width;
    if(p6.x < 0)            p6.x = 0;
    points[npoints].x = p6.x;
    points[npoints++].y = height - p6.y;
    if(p6.y < height && p3.x > 0){
      points[npoints].x = 0;
      points[npoints++].y = 0;
    }
  }

  XFillPolygon(Dpy,pix,loc_gc,points,npoints,Nonconvex,CoordModeOrigin);
  XFreeGC(Dpy,loc_gc);
  char khn[256];
  sprintf(khn,"Build diagonal clip mask at orig = (%d, %d) line width = %d angle = %d\n",
	  x_orig,y_orig,span,angle);
  insertStringtoInfo(khn);
  return pix;
}

Pixmap Xet::creatMeshMask(int width,int height,int x_orig,int y_orig,
			  int xspacing,int yspacing,int xwidth,int ywidth,
			  int angle,ShapeMode shapeMode)
{
  GC            loc_gc;
  XGCValues     gvals; 
  Pixmap pix = XCreatePixmap(Dpy,drawingArea->window,width,height,1);
  loc_gc = XCreateGC(Dpy,pix, 0, &gvals);
  XSetForeground(Dpy,loc_gc,WhitePixel(Dpy,DefaultScreen(Dpy)));
  XFillRectangle(Dpy,pix,loc_gc,0,0,width,height);
  XSetForeground(Dpy,loc_gc,BlackPixel(Dpy,DefaultScreen(Dpy)));
  XSetBackground(Dpy,loc_gc,WhitePixel(Dpy,DefaultScreen(Dpy)));

  if(shapeMode == SOLID_E){
    XSetFunction(Dpy,loc_gc,GXcopy);
  }else{
    XFillRectangle(Dpy,pix,loc_gc,0,0,width,height);
    XSetFunction(Dpy,loc_gc,GXcopyInverted);
  }

  XSetLineAttributes(Dpy,loc_gc,(unsigned int) xwidth,LineSolid,CapRound,
		     JoinRound);
  
  XPoint po,p1,p2,p3;
  po.x = x_orig;
  po.y = y_orig;
  int i;
  double a, b;
  if(findInteraction(&po,width,height,angle,&p2,&p3) == 1){
    XDrawLine(Dpy,pix,loc_gc,p2.x,height - p2.y,p3.x,height - p3.y);
  }
  if(angle >= 0 && angle < 90){
    for(i = 0;;i++){
      a = xspacing * (i+1) * sin(0.0175*angle);
      b = xspacing * (i+1) * cos(0.0175*angle);
      p1.x = po.x - (short)a;
      p1.y = po.y + (short)b;
      if(findInteraction(&p1,width,height,angle,&p2,&p3) == 1){
	XDrawLine(Dpy,pix,loc_gc,p2.x,height - p2.y,p3.x,height - p3.y);
      }
      else
	break;
    }
    for(i = 0;;i++){
      a = xspacing * (i+1) * sin(0.0175*angle);
      b = xspacing * (i+1) * cos(0.0175*angle);
      p1.x = po.x + (short)a;
      p1.y = po.y - (short)b;
      if(findInteraction(&p1,width,height,angle,&p2,&p3) == 1){
	XDrawLine(Dpy,pix,loc_gc,p2.x,height - p2.y,p3.x,height - p3.y);
      }
      else
	break;
    }
    // now do the other way
    XSetLineAttributes(Dpy,loc_gc,(unsigned int) ywidth,LineSolid,CapRound,
		       JoinRound);
    if(findInteraction(&po,width,height,angle+90,&p2,&p3) == 1){
      XDrawLine(Dpy,pix,loc_gc,p2.x,height - p2.y,p3.x,height - p3.y);
    }
    for(i = 0;;i++){
      a = yspacing * (i+1) * sin(0.0175*(90+angle));
      b = yspacing * (i+1) * cos(0.0175*(90+angle));
      p1.x = po.x - (short)a;
      p1.y = po.y + (short)b;
      if(findInteraction(&p1,width,height,angle+90,&p2,&p3) == 1){
	XDrawLine(Dpy,pix,loc_gc,p2.x,height - p2.y,p3.x,height - p3.y);
      }
      else
	break;
    }
    for(i = 0;;i++){
      a = yspacing * (i+1) * sin(0.0175*(90+angle));
      b = yspacing * (i+1) * cos(0.0175*(90+angle));
      p1.x = po.x + (short)a;
      p1.y = po.y - (short)b;
      if(findInteraction(&p1,width,height,angle+90,&p2,&p3) == 1){
	XDrawLine(Dpy,pix,loc_gc,p2.x,height - p2.y,p3.x,height - p3.y);
      }
      else
	break;
    }
  }
  XFreeGC(Dpy,loc_gc);
  char khn[256];
  sprintf(khn,"Build mesh clip mask at orig = (%d, %d) spaceing = (%d %d) line width = (%d %d) angle = %d\n",
	  x_orig,y_orig,xspacing, yspacing, xwidth,ywidth,angle);
  insertStringtoInfo(khn);
  return pix;
}




