//
//  Xet - X Entertainment (a tool to create animated images)
//
//
//  Author:   Ko-Haw Nieh & Coalition Software, (nieh@netcom.com)
//
//
//  Copyright 1992, 1993 by Ko-Haw Nieh & Coalition Software
//
// Permission to use, copy, and distribute for non-commercial purposes,
// is hereby granted without fee, providing that the above copyright
// notice appear in all copies and that both the copyright notice and this
// permission notice appear in supporting documentation. 
//
// This software is provided as-is and without any warranty of any kind.

#include <stdlib.h>
#include <sys/types.h>
#include <sys/time.h>
#include "config.h"
#include "xet.h"
#include <libc.h>
#include <osfcn.h>
#include <string.h>
#include "util.h"
#include "procSpooler.h"

extern int             asyncResult;

void Xet::buildSpoolList(){
  updateSpoolerPanel();
}

void Xet::updateSpoolerPanel(){
  Widget  queueList = nameToWidget("spoolerTBL*queueList");
  if(queueList)
    procSpooler->buildQueueXmList(queueList);
  updateSpoolerStatus();
  updateXetStatistic();
}

void Xet::spoolerDelete(){
  Widget spoolerTBL  = nameToWidget("spoolerTBL");
  Widget  queueList  = nameToWidget("spoolerTBL*queueList");
  int size,*ary[2];
  Boolean rtn;
  rtn = XmListGetSelectedPos(queueList,ary,&size);
  if(rtn){
    if(*ary[0] > 1){
      Widget areYouSureTBL = createAreYouSureDialog("Delete selected queued item, Are you sure ?");
      int rtn1 = performAsyncInteraction(Dpy,areYouSureTBL);
      if(rtn1){
	XmListDeletePos(queueList,*ary[0]);
	procSpooler->Delete(*ary[0]);
      }
      destroyAreYouSureDialog();
    }else
      popupModalInfoBox("Can not delete this one, it is already scheduled or queue is empty\n");
  }else
    popupModalInfoBox("Must select an item");

}
void Xet::spoolerDeleteAll(){
  Widget spoolerTBL    = nameToWidget("spoolerTBL");
  Widget  queueList    = nameToWidget("spoolerTBL*queueList");
  Widget areYouSureTBL = createAreYouSureDialog("Delete all queued items, Are you sure ?");
  int rtn = performAsyncInteraction(Dpy,areYouSureTBL);
  if(rtn){
    procSpooler->DeleteAll();
    // the following 100 is assumed, I bet nobody will spool 100 jobs 
    // the XmList will delete everything after item 2
    XmListDeleteItemsPos(queueList,100,2);
  }
  destroyAreYouSureDialog();
}
  
void Xet::spoolerClose(){
  Widget w = nameToWidget("*spooler");
  XtSetSensitive(w,True);
}

void Xet::updateSpoolerStatus(){
  Widget  s = nameToWidget("spoolerTBL*spoolerSuspend");
  Widget  r = nameToWidget("spoolerTBL*spoolerResume");
  if(s && r){
     switch(procSpooler->getSpoolerStatus()){
     case SUSPEND_E :   XtSetSensitive(s,False);
		        XtSetSensitive(r,True);
		        break;
     case RESUME_E:     XtSetSensitive(s,True);
                        XtSetSensitive(r,False);
                        break;
		      }
   }  
}

void Xet::spoolerSuspend(){
  procSpooler->setSpoolerStatus(SUSPEND_E);
  updateSpoolerStatus();
}

void Xet::spoolerResume(){
  procSpooler->setSpoolerStatus(RESUME_E);
  updateSpoolerStatus();
}

void Xet::spoolerMoveDown(){
  Widget  queueList = nameToWidget("spoolerTBL*queueList");
  int size,*ary[2];
  Boolean rtn;
  rtn = XmListGetSelectedPos(queueList,ary,&size);
  if(rtn){
    if(*ary[0] > 1){
      procSpooler->moveDown(*ary[0]);
    }else
      popupModalInfoBox("Can not move this one, it is already scheduled or queue is empty\n");
  }else
    popupModalInfoBox("Must select an item");
}

void Xet::spoolerMoveUp(){
  Widget  queueList = nameToWidget("spoolerTBL*queueList");
  int size,*ary[2];
  Boolean rtn;
  rtn = XmListGetSelectedPos(queueList,ary,&size);
  if(rtn){
    if(*ary[0] > 1){
      procSpooler->moveUp(*ary[0]);
    }else
      popupModalInfoBox("Can not move this one, it is already scheduled or queue is empty");
  }else
    popupModalInfoBox("Must select an item");
}

